# Rust API client for bitwarden-api-api

No description provided (generated by Openapi Generator
https://github.com/openapitools/openapi-generator)

## Overview

This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project. By
using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API
client.

- API version: latest
- Package version: 0.5.0
- Generator version: 7.6.0
- Build package: `org.openapitools.codegen.languages.RustClientCodegen`

## Installation

Put the package under your project folder in a directory named `bitwarden-api-api` and add the
following to `Cargo.toml` under `[dependencies]`:

```
bitwarden-api-api = { path = "./bitwarden-api-api" }
```

## Documentation for API Endpoints

All URIs are relative to _http://localhost_

| Class                                   | Method                                                                                                                                                                                                                       | HTTP request                                                                             | Description                                                      |
| --------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------- | ---------------------------------------------------------------- |
| _AccessPoliciesApi_                     | [**organizations_id_access_policies_people_potential_grantees_get**](docs/AccessPoliciesApi.md#organizations_id_access_policies_people_potential_grantees_get)                                                               | **GET** /organizations/{id}/access-policies/people/potential-grantees                    |
| _AccessPoliciesApi_                     | [**organizations_id_access_policies_projects_potential_grantees_get**](docs/AccessPoliciesApi.md#organizations_id_access_policies_projects_potential_grantees_get)                                                           | **GET** /organizations/{id}/access-policies/projects/potential-grantees                  |
| _AccessPoliciesApi_                     | [**organizations_id_access_policies_service_accounts_potential_grantees_get**](docs/AccessPoliciesApi.md#organizations_id_access_policies_service_accounts_potential_grantees_get)                                           | **GET** /organizations/{id}/access-policies/service-accounts/potential-grantees          |
| _AccessPoliciesApi_                     | [**projects_id_access_policies_people_get**](docs/AccessPoliciesApi.md#projects_id_access_policies_people_get)                                                                                                               | **GET** /projects/{id}/access-policies/people                                            |
| _AccessPoliciesApi_                     | [**projects_id_access_policies_people_put**](docs/AccessPoliciesApi.md#projects_id_access_policies_people_put)                                                                                                               | **PUT** /projects/{id}/access-policies/people                                            |
| _AccessPoliciesApi_                     | [**projects_id_access_policies_service_accounts_get**](docs/AccessPoliciesApi.md#projects_id_access_policies_service_accounts_get)                                                                                           | **GET** /projects/{id}/access-policies/service-accounts                                  |
| _AccessPoliciesApi_                     | [**projects_id_access_policies_service_accounts_put**](docs/AccessPoliciesApi.md#projects_id_access_policies_service_accounts_put)                                                                                           | **PUT** /projects/{id}/access-policies/service-accounts                                  |
| _AccessPoliciesApi_                     | [**secrets_secret_id_access_policies_get**](docs/AccessPoliciesApi.md#secrets_secret_id_access_policies_get)                                                                                                                 | **GET** /secrets/{secretId}/access-policies                                              |
| _AccessPoliciesApi_                     | [**service_accounts_id_access_policies_people_get**](docs/AccessPoliciesApi.md#service_accounts_id_access_policies_people_get)                                                                                               | **GET** /service-accounts/{id}/access-policies/people                                    |
| _AccessPoliciesApi_                     | [**service_accounts_id_access_policies_people_put**](docs/AccessPoliciesApi.md#service_accounts_id_access_policies_people_put)                                                                                               | **PUT** /service-accounts/{id}/access-policies/people                                    |
| _AccessPoliciesApi_                     | [**service_accounts_id_granted_policies_get**](docs/AccessPoliciesApi.md#service_accounts_id_granted_policies_get)                                                                                                           | **GET** /service-accounts/{id}/granted-policies                                          |
| _AccessPoliciesApi_                     | [**service_accounts_id_granted_policies_put**](docs/AccessPoliciesApi.md#service_accounts_id_granted_policies_put)                                                                                                           | **PUT** /service-accounts/{id}/granted-policies                                          |
| _AccountsApi_                           | [**accounts_api_key_post**](docs/AccountsApi.md#accounts_api_key_post)                                                                                                                                                       | **POST** /accounts/api-key                                                               |
| _AccountsApi_                           | [**accounts_avatar_post**](docs/AccountsApi.md#accounts_avatar_post)                                                                                                                                                         | **POST** /accounts/avatar                                                                |
| _AccountsApi_                           | [**accounts_avatar_put**](docs/AccountsApi.md#accounts_avatar_put)                                                                                                                                                           | **PUT** /accounts/avatar                                                                 |
| _AccountsApi_                           | [**accounts_cancel_post**](docs/AccountsApi.md#accounts_cancel_post)                                                                                                                                                         | **POST** /accounts/cancel                                                                |
| _AccountsApi_                           | [**accounts_convert_to_key_connector_post**](docs/AccountsApi.md#accounts_convert_to_key_connector_post)                                                                                                                     | **POST** /accounts/convert-to-key-connector                                              |
| _AccountsApi_                           | [**accounts_delete**](docs/AccountsApi.md#accounts_delete)                                                                                                                                                                   | **DELETE** /accounts                                                                     |
| _AccountsApi_                           | [**accounts_delete_post**](docs/AccountsApi.md#accounts_delete_post)                                                                                                                                                         | **POST** /accounts/delete                                                                |
| _AccountsApi_                           | [**accounts_delete_recover_post**](docs/AccountsApi.md#accounts_delete_recover_post)                                                                                                                                         | **POST** /accounts/delete-recover                                                        |
| _AccountsApi_                           | [**accounts_delete_recover_token_post**](docs/AccountsApi.md#accounts_delete_recover_token_post)                                                                                                                             | **POST** /accounts/delete-recover-token                                                  |
| _AccountsApi_                           | [**accounts_email_post**](docs/AccountsApi.md#accounts_email_post)                                                                                                                                                           | **POST** /accounts/email                                                                 |
| _AccountsApi_                           | [**accounts_email_token_post**](docs/AccountsApi.md#accounts_email_token_post)                                                                                                                                               | **POST** /accounts/email-token                                                           |
| _AccountsApi_                           | [**accounts_kdf_post**](docs/AccountsApi.md#accounts_kdf_post)                                                                                                                                                               | **POST** /accounts/kdf                                                                   |
| _AccountsApi_                           | [**accounts_key_post**](docs/AccountsApi.md#accounts_key_post)                                                                                                                                                               | **POST** /accounts/key                                                                   |
| _AccountsApi_                           | [**accounts_keys_get**](docs/AccountsApi.md#accounts_keys_get)                                                                                                                                                               | **GET** /accounts/keys                                                                   |
| _AccountsApi_                           | [**accounts_keys_post**](docs/AccountsApi.md#accounts_keys_post)                                                                                                                                                             | **POST** /accounts/keys                                                                  |
| _AccountsApi_                           | [**accounts_license_post**](docs/AccountsApi.md#accounts_license_post)                                                                                                                                                       | **POST** /accounts/license                                                               |
| _AccountsApi_                           | [**accounts_organizations_get**](docs/AccountsApi.md#accounts_organizations_get)                                                                                                                                             | **GET** /accounts/organizations                                                          |
| _AccountsApi_                           | [**accounts_password_hint_post**](docs/AccountsApi.md#accounts_password_hint_post)                                                                                                                                           | **POST** /accounts/password-hint                                                         |
| _AccountsApi_                           | [**accounts_password_post**](docs/AccountsApi.md#accounts_password_post)                                                                                                                                                     | **POST** /accounts/password                                                              |
| _AccountsApi_                           | [**accounts_payment_post**](docs/AccountsApi.md#accounts_payment_post)                                                                                                                                                       | **POST** /accounts/payment                                                               |
| _AccountsApi_                           | [**accounts_premium_post**](docs/AccountsApi.md#accounts_premium_post)                                                                                                                                                       | **POST** /accounts/premium                                                               |
| _AccountsApi_                           | [**accounts_profile_get**](docs/AccountsApi.md#accounts_profile_get)                                                                                                                                                         | **GET** /accounts/profile                                                                |
| _AccountsApi_                           | [**accounts_profile_post**](docs/AccountsApi.md#accounts_profile_post)                                                                                                                                                       | **POST** /accounts/profile                                                               |
| _AccountsApi_                           | [**accounts_profile_put**](docs/AccountsApi.md#accounts_profile_put)                                                                                                                                                         | **PUT** /accounts/profile                                                                |
| _AccountsApi_                           | [**accounts_reinstate_premium_post**](docs/AccountsApi.md#accounts_reinstate_premium_post)                                                                                                                                   | **POST** /accounts/reinstate-premium                                                     |
| _AccountsApi_                           | [**accounts_request_otp_post**](docs/AccountsApi.md#accounts_request_otp_post)                                                                                                                                               | **POST** /accounts/request-otp                                                           |
| _AccountsApi_                           | [**accounts_revision_date_get**](docs/AccountsApi.md#accounts_revision_date_get)                                                                                                                                             | **GET** /accounts/revision-date                                                          |
| _AccountsApi_                           | [**accounts_rotate_api_key_post**](docs/AccountsApi.md#accounts_rotate_api_key_post)                                                                                                                                         | **POST** /accounts/rotate-api-key                                                        |
| _AccountsApi_                           | [**accounts_security_stamp_post**](docs/AccountsApi.md#accounts_security_stamp_post)                                                                                                                                         | **POST** /accounts/security-stamp                                                        |
| _AccountsApi_                           | [**accounts_set_key_connector_key_post**](docs/AccountsApi.md#accounts_set_key_connector_key_post)                                                                                                                           | **POST** /accounts/set-key-connector-key                                                 |
| _AccountsApi_                           | [**accounts_set_password_post**](docs/AccountsApi.md#accounts_set_password_post)                                                                                                                                             | **POST** /accounts/set-password                                                          |
| _AccountsApi_                           | [**accounts_sso_organization_id_delete**](docs/AccountsApi.md#accounts_sso_organization_id_delete)                                                                                                                           | **DELETE** /accounts/sso/{organizationId}                                                |
| _AccountsApi_                           | [**accounts_sso_user_identifier_get**](docs/AccountsApi.md#accounts_sso_user_identifier_get)                                                                                                                                 | **GET** /accounts/sso/user-identifier                                                    |
| _AccountsApi_                           | [**accounts_storage_post**](docs/AccountsApi.md#accounts_storage_post)                                                                                                                                                       | **POST** /accounts/storage                                                               |
| _AccountsApi_                           | [**accounts_subscription_get**](docs/AccountsApi.md#accounts_subscription_get)                                                                                                                                               | **GET** /accounts/subscription                                                           |
| _AccountsApi_                           | [**accounts_tax_get**](docs/AccountsApi.md#accounts_tax_get)                                                                                                                                                                 | **GET** /accounts/tax                                                                    |
| _AccountsApi_                           | [**accounts_tax_put**](docs/AccountsApi.md#accounts_tax_put)                                                                                                                                                                 | **PUT** /accounts/tax                                                                    |
| _AccountsApi_                           | [**accounts_update_tde_offboarding_password_put**](docs/AccountsApi.md#accounts_update_tde_offboarding_password_put)                                                                                                         | **PUT** /accounts/update-tde-offboarding-password                                        |
| _AccountsApi_                           | [**accounts_update_temp_password_put**](docs/AccountsApi.md#accounts_update_temp_password_put)                                                                                                                               | **PUT** /accounts/update-temp-password                                                   |
| _AccountsApi_                           | [**accounts_verify_email_post**](docs/AccountsApi.md#accounts_verify_email_post)                                                                                                                                             | **POST** /accounts/verify-email                                                          |
| _AccountsApi_                           | [**accounts_verify_email_token_post**](docs/AccountsApi.md#accounts_verify_email_token_post)                                                                                                                                 | **POST** /accounts/verify-email-token                                                    |
| _AccountsApi_                           | [**accounts_verify_otp_post**](docs/AccountsApi.md#accounts_verify_otp_post)                                                                                                                                                 | **POST** /accounts/verify-otp                                                            |
| _AccountsApi_                           | [**accounts_verify_password_post**](docs/AccountsApi.md#accounts_verify_password_post)                                                                                                                                       | **POST** /accounts/verify-password                                                       |
| _AccountsBillingApi_                    | [**accounts_billing_history_get**](docs/AccountsBillingApi.md#accounts_billing_history_get)                                                                                                                                  | **GET** /accounts/billing/history                                                        |
| _AccountsBillingApi_                    | [**accounts_billing_payment_method_get**](docs/AccountsBillingApi.md#accounts_billing_payment_method_get)                                                                                                                    | **GET** /accounts/billing/payment-method                                                 |
| _AuthRequestsApi_                       | [**auth_requests_admin_request_post**](docs/AuthRequestsApi.md#auth_requests_admin_request_post)                                                                                                                             | **POST** /auth-requests/admin-request                                                    |
| _AuthRequestsApi_                       | [**auth_requests_get**](docs/AuthRequestsApi.md#auth_requests_get)                                                                                                                                                           | **GET** /auth-requests                                                                   |
| _AuthRequestsApi_                       | [**auth_requests_id_get**](docs/AuthRequestsApi.md#auth_requests_id_get)                                                                                                                                                     | **GET** /auth-requests/{id}                                                              |
| _AuthRequestsApi_                       | [**auth_requests_id_put**](docs/AuthRequestsApi.md#auth_requests_id_put)                                                                                                                                                     | **PUT** /auth-requests/{id}                                                              |
| _AuthRequestsApi_                       | [**auth_requests_id_response_get**](docs/AuthRequestsApi.md#auth_requests_id_response_get)                                                                                                                                   | **GET** /auth-requests/{id}/response                                                     |
| _AuthRequestsApi_                       | [**auth_requests_post**](docs/AuthRequestsApi.md#auth_requests_post)                                                                                                                                                         | **POST** /auth-requests                                                                  |
| _CiphersApi_                            | [**ciphers_admin_delete**](docs/CiphersApi.md#ciphers_admin_delete)                                                                                                                                                          | **DELETE** /ciphers/admin                                                                |
| _CiphersApi_                            | [**ciphers_admin_post**](docs/CiphersApi.md#ciphers_admin_post)                                                                                                                                                              | **POST** /ciphers/admin                                                                  |
| _CiphersApi_                            | [**ciphers_attachment_validate_azure_post**](docs/CiphersApi.md#ciphers_attachment_validate_azure_post)                                                                                                                      | **POST** /ciphers/attachment/validate/azure                                              |
| _CiphersApi_                            | [**ciphers_bulk_collections_post**](docs/CiphersApi.md#ciphers_bulk_collections_post)                                                                                                                                        | **POST** /ciphers/bulk-collections                                                       |
| _CiphersApi_                            | [**ciphers_create_post**](docs/CiphersApi.md#ciphers_create_post)                                                                                                                                                            | **POST** /ciphers/create                                                                 |
| _CiphersApi_                            | [**ciphers_delete**](docs/CiphersApi.md#ciphers_delete)                                                                                                                                                                      | **DELETE** /ciphers                                                                      |
| _CiphersApi_                            | [**ciphers_delete_admin_post**](docs/CiphersApi.md#ciphers_delete_admin_post)                                                                                                                                                | **POST** /ciphers/delete-admin                                                           |
| _CiphersApi_                            | [**ciphers_delete_admin_put**](docs/CiphersApi.md#ciphers_delete_admin_put)                                                                                                                                                  | **PUT** /ciphers/delete-admin                                                            |
| _CiphersApi_                            | [**ciphers_delete_post**](docs/CiphersApi.md#ciphers_delete_post)                                                                                                                                                            | **POST** /ciphers/delete                                                                 |
| _CiphersApi_                            | [**ciphers_delete_put**](docs/CiphersApi.md#ciphers_delete_put)                                                                                                                                                              | **PUT** /ciphers/delete                                                                  |
| _CiphersApi_                            | [**ciphers_get**](docs/CiphersApi.md#ciphers_get)                                                                                                                                                                            | **GET** /ciphers                                                                         |
| _CiphersApi_                            | [**ciphers_id_admin_delete**](docs/CiphersApi.md#ciphers_id_admin_delete)                                                                                                                                                    | **DELETE** /ciphers/{id}/admin                                                           |
| _CiphersApi_                            | [**ciphers_id_admin_get**](docs/CiphersApi.md#ciphers_id_admin_get)                                                                                                                                                          | **GET** /ciphers/{id}/admin                                                              |
| _CiphersApi_                            | [**ciphers_id_admin_post**](docs/CiphersApi.md#ciphers_id_admin_post)                                                                                                                                                        | **POST** /ciphers/{id}/admin                                                             |
| _CiphersApi_                            | [**ciphers_id_admin_put**](docs/CiphersApi.md#ciphers_id_admin_put)                                                                                                                                                          | **PUT** /ciphers/{id}/admin                                                              |
| _CiphersApi_                            | [**ciphers_id_attachment_admin_post**](docs/CiphersApi.md#ciphers_id_attachment_admin_post)                                                                                                                                  | **POST** /ciphers/{id}/attachment-admin                                                  |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_admin_delete**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_admin_delete)                                                                                                  | **DELETE** /ciphers/{id}/attachment/{attachmentId}/admin                                 |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_delete**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_delete)                                                                                                              | **DELETE** /ciphers/{id}/attachment/{attachmentId}                                       |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_delete_admin_post**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_delete_admin_post)                                                                                        | **POST** /ciphers/{id}/attachment/{attachmentId}/delete-admin                            |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_delete_post**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_delete_post)                                                                                                    | **POST** /ciphers/{id}/attachment/{attachmentId}/delete                                  |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_get**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_get)                                                                                                                    | **GET** /ciphers/{id}/attachment/{attachmentId}                                          |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_post**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_post)                                                                                                                  | **POST** /ciphers/{id}/attachment/{attachmentId}                                         |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_renew_get**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_renew_get)                                                                                                        | **GET** /ciphers/{id}/attachment/{attachmentId}/renew                                    |
| _CiphersApi_                            | [**ciphers_id_attachment_attachment_id_share_post**](docs/CiphersApi.md#ciphers_id_attachment_attachment_id_share_post)                                                                                                      | **POST** /ciphers/{id}/attachment/{attachmentId}/share                                   |
| _CiphersApi_                            | [**ciphers_id_attachment_post**](docs/CiphersApi.md#ciphers_id_attachment_post)                                                                                                                                              | **POST** /ciphers/{id}/attachment                                                        |
| _CiphersApi_                            | [**ciphers_id_attachment_v2_post**](docs/CiphersApi.md#ciphers_id_attachment_v2_post)                                                                                                                                        | **POST** /ciphers/{id}/attachment/v2                                                     |
| _CiphersApi_                            | [**ciphers_id_collections_admin_post**](docs/CiphersApi.md#ciphers_id_collections_admin_post)                                                                                                                                | **POST** /ciphers/{id}/collections-admin                                                 |
| _CiphersApi_                            | [**ciphers_id_collections_admin_put**](docs/CiphersApi.md#ciphers_id_collections_admin_put)                                                                                                                                  | **PUT** /ciphers/{id}/collections-admin                                                  |
| _CiphersApi_                            | [**ciphers_id_collections_post**](docs/CiphersApi.md#ciphers_id_collections_post)                                                                                                                                            | **POST** /ciphers/{id}/collections                                                       |
| _CiphersApi_                            | [**ciphers_id_collections_put**](docs/CiphersApi.md#ciphers_id_collections_put)                                                                                                                                              | **PUT** /ciphers/{id}/collections                                                        |
| _CiphersApi_                            | [**ciphers_id_collections_v2_post**](docs/CiphersApi.md#ciphers_id_collections_v2_post)                                                                                                                                      | **POST** /ciphers/{id}/collections_v2                                                    |
| _CiphersApi_                            | [**ciphers_id_collections_v2_put**](docs/CiphersApi.md#ciphers_id_collections_v2_put)                                                                                                                                        | **PUT** /ciphers/{id}/collections_v2                                                     |
| _CiphersApi_                            | [**ciphers_id_delete**](docs/CiphersApi.md#ciphers_id_delete)                                                                                                                                                                | **DELETE** /ciphers/{id}                                                                 |
| _CiphersApi_                            | [**ciphers_id_delete_admin_post**](docs/CiphersApi.md#ciphers_id_delete_admin_post)                                                                                                                                          | **POST** /ciphers/{id}/delete-admin                                                      |
| _CiphersApi_                            | [**ciphers_id_delete_admin_put**](docs/CiphersApi.md#ciphers_id_delete_admin_put)                                                                                                                                            | **PUT** /ciphers/{id}/delete-admin                                                       |
| _CiphersApi_                            | [**ciphers_id_delete_post**](docs/CiphersApi.md#ciphers_id_delete_post)                                                                                                                                                      | **POST** /ciphers/{id}/delete                                                            |
| _CiphersApi_                            | [**ciphers_id_delete_put**](docs/CiphersApi.md#ciphers_id_delete_put)                                                                                                                                                        | **PUT** /ciphers/{id}/delete                                                             |
| _CiphersApi_                            | [**ciphers_id_details_get**](docs/CiphersApi.md#ciphers_id_details_get)                                                                                                                                                      | **GET** /ciphers/{id}/details                                                            |
| _CiphersApi_                            | [**ciphers_id_full_details_get**](docs/CiphersApi.md#ciphers_id_full_details_get)                                                                                                                                            | **GET** /ciphers/{id}/full-details                                                       |
| _CiphersApi_                            | [**ciphers_id_get**](docs/CiphersApi.md#ciphers_id_get)                                                                                                                                                                      | **GET** /ciphers/{id}                                                                    |
| _CiphersApi_                            | [**ciphers_id_partial_post**](docs/CiphersApi.md#ciphers_id_partial_post)                                                                                                                                                    | **POST** /ciphers/{id}/partial                                                           |
| _CiphersApi_                            | [**ciphers_id_partial_put**](docs/CiphersApi.md#ciphers_id_partial_put)                                                                                                                                                      | **PUT** /ciphers/{id}/partial                                                            |
| _CiphersApi_                            | [**ciphers_id_post**](docs/CiphersApi.md#ciphers_id_post)                                                                                                                                                                    | **POST** /ciphers/{id}                                                                   |
| _CiphersApi_                            | [**ciphers_id_put**](docs/CiphersApi.md#ciphers_id_put)                                                                                                                                                                      | **PUT** /ciphers/{id}                                                                    |
| _CiphersApi_                            | [**ciphers_id_restore_admin_put**](docs/CiphersApi.md#ciphers_id_restore_admin_put)                                                                                                                                          | **PUT** /ciphers/{id}/restore-admin                                                      |
| _CiphersApi_                            | [**ciphers_id_restore_put**](docs/CiphersApi.md#ciphers_id_restore_put)                                                                                                                                                      | **PUT** /ciphers/{id}/restore                                                            |
| _CiphersApi_                            | [**ciphers_id_share_post**](docs/CiphersApi.md#ciphers_id_share_post)                                                                                                                                                        | **POST** /ciphers/{id}/share                                                             |
| _CiphersApi_                            | [**ciphers_id_share_put**](docs/CiphersApi.md#ciphers_id_share_put)                                                                                                                                                          | **PUT** /ciphers/{id}/share                                                              |
| _CiphersApi_                            | [**ciphers_move_post**](docs/CiphersApi.md#ciphers_move_post)                                                                                                                                                                | **POST** /ciphers/move                                                                   |
| _CiphersApi_                            | [**ciphers_move_put**](docs/CiphersApi.md#ciphers_move_put)                                                                                                                                                                  | **PUT** /ciphers/move                                                                    |
| _CiphersApi_                            | [**ciphers_organization_details_assigned_get**](docs/CiphersApi.md#ciphers_organization_details_assigned_get)                                                                                                                | **GET** /ciphers/organization-details/assigned                                           |
| _CiphersApi_                            | [**ciphers_organization_details_get**](docs/CiphersApi.md#ciphers_organization_details_get)                                                                                                                                  | **GET** /ciphers/organization-details                                                    |
| _CiphersApi_                            | [**ciphers_post**](docs/CiphersApi.md#ciphers_post)                                                                                                                                                                          | **POST** /ciphers                                                                        |
| _CiphersApi_                            | [**ciphers_purge_post**](docs/CiphersApi.md#ciphers_purge_post)                                                                                                                                                              | **POST** /ciphers/purge                                                                  |
| _CiphersApi_                            | [**ciphers_restore_admin_put**](docs/CiphersApi.md#ciphers_restore_admin_put)                                                                                                                                                | **PUT** /ciphers/restore-admin                                                           |
| _CiphersApi_                            | [**ciphers_restore_put**](docs/CiphersApi.md#ciphers_restore_put)                                                                                                                                                            | **PUT** /ciphers/restore                                                                 |
| _CiphersApi_                            | [**ciphers_share_post**](docs/CiphersApi.md#ciphers_share_post)                                                                                                                                                              | **POST** /ciphers/share                                                                  |
| _CiphersApi_                            | [**ciphers_share_put**](docs/CiphersApi.md#ciphers_share_put)                                                                                                                                                                | **PUT** /ciphers/share                                                                   |
| _CollectionsApi_                        | [**collections_get**](docs/CollectionsApi.md#collections_get)                                                                                                                                                                | **GET** /collections                                                                     |
| _CollectionsApi_                        | [**organizations_org_id_collections_bulk_access_post**](docs/CollectionsApi.md#organizations_org_id_collections_bulk_access_post)                                                                                            | **POST** /organizations/{orgId}/collections/bulk-access                                  |
| _CollectionsApi_                        | [**organizations_org_id_collections_delete**](docs/CollectionsApi.md#organizations_org_id_collections_delete)                                                                                                                | **DELETE** /organizations/{orgId}/collections                                            |
| _CollectionsApi_                        | [**organizations_org_id_collections_delete_post**](docs/CollectionsApi.md#organizations_org_id_collections_delete_post)                                                                                                      | **POST** /organizations/{orgId}/collections/delete                                       |
| _CollectionsApi_                        | [**organizations_org_id_collections_details_get**](docs/CollectionsApi.md#organizations_org_id_collections_details_get)                                                                                                      | **GET** /organizations/{orgId}/collections/details                                       |
| _CollectionsApi_                        | [**organizations_org_id_collections_get**](docs/CollectionsApi.md#organizations_org_id_collections_get)                                                                                                                      | **GET** /organizations/{orgId}/collections                                               |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_delete**](docs/CollectionsApi.md#organizations_org_id_collections_id_delete)                                                                                                          | **DELETE** /organizations/{orgId}/collections/{id}                                       |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_delete_post**](docs/CollectionsApi.md#organizations_org_id_collections_id_delete_post)                                                                                                | **POST** /organizations/{orgId}/collections/{id}/delete                                  |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_delete_user_org_user_id_post**](docs/CollectionsApi.md#organizations_org_id_collections_id_delete_user_org_user_id_post)                                                              | **POST** /organizations/{orgId}/collections/{id}/delete-user/{orgUserId}                 |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_details_get**](docs/CollectionsApi.md#organizations_org_id_collections_id_details_get)                                                                                                | **GET** /organizations/{orgId}/collections/{id}/details                                  |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_get**](docs/CollectionsApi.md#organizations_org_id_collections_id_get)                                                                                                                | **GET** /organizations/{orgId}/collections/{id}                                          |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_post**](docs/CollectionsApi.md#organizations_org_id_collections_id_post)                                                                                                              | **POST** /organizations/{orgId}/collections/{id}                                         |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_put**](docs/CollectionsApi.md#organizations_org_id_collections_id_put)                                                                                                                | **PUT** /organizations/{orgId}/collections/{id}                                          |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_user_org_user_id_delete**](docs/CollectionsApi.md#organizations_org_id_collections_id_user_org_user_id_delete)                                                                        | **DELETE** /organizations/{orgId}/collections/{id}/user/{orgUserId}                      |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_users_get**](docs/CollectionsApi.md#organizations_org_id_collections_id_users_get)                                                                                                    | **GET** /organizations/{orgId}/collections/{id}/users                                    |
| _CollectionsApi_                        | [**organizations_org_id_collections_id_users_put**](docs/CollectionsApi.md#organizations_org_id_collections_id_users_put)                                                                                                    | **PUT** /organizations/{orgId}/collections/{id}/users                                    |
| _CollectionsApi_                        | [**organizations_org_id_collections_post**](docs/CollectionsApi.md#organizations_org_id_collections_post)                                                                                                                    | **POST** /organizations/{orgId}/collections                                              |
| _ConfigApi_                             | [**config_get**](docs/ConfigApi.md#config_get)                                                                                                                                                                               | **GET** /config                                                                          |
| _CountsApi_                             | [**organizations_organization_id_sm_counts_get**](docs/CountsApi.md#organizations_organization_id_sm_counts_get)                                                                                                             | **GET** /organizations/{organizationId}/sm-counts                                        |
| _CountsApi_                             | [**projects_project_id_sm_counts_get**](docs/CountsApi.md#projects_project_id_sm_counts_get)                                                                                                                                 | **GET** /projects/{projectId}/sm-counts                                                  |
| _CountsApi_                             | [**service_accounts_service_account_id_sm_counts_get**](docs/CountsApi.md#service_accounts_service_account_id_sm_counts_get)                                                                                                 | **GET** /service-accounts/{serviceAccountId}/sm-counts                                   |
| _DevicesApi_                            | [**devices_get**](docs/DevicesApi.md#devices_get)                                                                                                                                                                            | **GET** /devices                                                                         |
| _DevicesApi_                            | [**devices_id_delete**](docs/DevicesApi.md#devices_id_delete)                                                                                                                                                                | **DELETE** /devices/{id}                                                                 |
| _DevicesApi_                            | [**devices_id_delete_post**](docs/DevicesApi.md#devices_id_delete_post)                                                                                                                                                      | **POST** /devices/{id}/delete                                                            |
| _DevicesApi_                            | [**devices_id_get**](docs/DevicesApi.md#devices_id_get)                                                                                                                                                                      | **GET** /devices/{id}                                                                    |
| _DevicesApi_                            | [**devices_id_post**](docs/DevicesApi.md#devices_id_post)                                                                                                                                                                    | **POST** /devices/{id}                                                                   |
| _DevicesApi_                            | [**devices_id_put**](docs/DevicesApi.md#devices_id_put)                                                                                                                                                                      | **PUT** /devices/{id}                                                                    |
| _DevicesApi_                            | [**devices_identifier_identifier_clear_token_post**](docs/DevicesApi.md#devices_identifier_identifier_clear_token_post)                                                                                                      | **POST** /devices/identifier/{identifier}/clear-token                                    |
| _DevicesApi_                            | [**devices_identifier_identifier_clear_token_put**](docs/DevicesApi.md#devices_identifier_identifier_clear_token_put)                                                                                                        | **PUT** /devices/identifier/{identifier}/clear-token                                     |
| _DevicesApi_                            | [**devices_identifier_identifier_get**](docs/DevicesApi.md#devices_identifier_identifier_get)                                                                                                                                | **GET** /devices/identifier/{identifier}                                                 |
| _DevicesApi_                            | [**devices_identifier_identifier_token_post**](docs/DevicesApi.md#devices_identifier_identifier_token_post)                                                                                                                  | **POST** /devices/identifier/{identifier}/token                                          |
| _DevicesApi_                            | [**devices_identifier_identifier_token_put**](docs/DevicesApi.md#devices_identifier_identifier_token_put)                                                                                                                    | **PUT** /devices/identifier/{identifier}/token                                           |
| _DevicesApi_                            | [**devices_identifier_keys_post**](docs/DevicesApi.md#devices_identifier_keys_post)                                                                                                                                          | **POST** /devices/{identifier}/keys                                                      |
| _DevicesApi_                            | [**devices_identifier_keys_put**](docs/DevicesApi.md#devices_identifier_keys_put)                                                                                                                                            | **PUT** /devices/{identifier}/keys                                                       |
| _DevicesApi_                            | [**devices_identifier_retrieve_keys_post**](docs/DevicesApi.md#devices_identifier_retrieve_keys_post)                                                                                                                        | **POST** /devices/{identifier}/retrieve-keys                                             |
| _DevicesApi_                            | [**devices_knowndevice_email_identifier_get**](docs/DevicesApi.md#devices_knowndevice_email_identifier_get)                                                                                                                  | **GET** /devices/knowndevice/{email}/{identifier}                                        |
| _DevicesApi_                            | [**devices_knowndevice_get**](docs/DevicesApi.md#devices_knowndevice_get)                                                                                                                                                    | **GET** /devices/knowndevice                                                             |
| _DevicesApi_                            | [**devices_lost_trust_post**](docs/DevicesApi.md#devices_lost_trust_post)                                                                                                                                                    | **POST** /devices/lost-trust                                                             |
| _DevicesApi_                            | [**devices_post**](docs/DevicesApi.md#devices_post)                                                                                                                                                                          | **POST** /devices                                                                        |
| _DevicesApi_                            | [**devices_update_trust_post**](docs/DevicesApi.md#devices_update_trust_post)                                                                                                                                                | **POST** /devices/update-trust                                                           |
| _EmergencyAccessApi_                    | [**emergency_access_granted_get**](docs/EmergencyAccessApi.md#emergency_access_granted_get)                                                                                                                                  | **GET** /emergency-access/granted                                                        |
| _EmergencyAccessApi_                    | [**emergency_access_id_accept_post**](docs/EmergencyAccessApi.md#emergency_access_id_accept_post)                                                                                                                            | **POST** /emergency-access/{id}/accept                                                   |
| _EmergencyAccessApi_                    | [**emergency_access_id_approve_post**](docs/EmergencyAccessApi.md#emergency_access_id_approve_post)                                                                                                                          | **POST** /emergency-access/{id}/approve                                                  |
| _EmergencyAccessApi_                    | [**emergency_access_id_cipher_id_attachment_attachment_id_get**](docs/EmergencyAccessApi.md#emergency_access_id_cipher_id_attachment_attachment_id_get)                                                                      | **GET** /emergency-access/{id}/{cipherId}/attachment/{attachmentId}                      |
| _EmergencyAccessApi_                    | [**emergency_access_id_confirm_post**](docs/EmergencyAccessApi.md#emergency_access_id_confirm_post)                                                                                                                          | **POST** /emergency-access/{id}/confirm                                                  |
| _EmergencyAccessApi_                    | [**emergency_access_id_delete**](docs/EmergencyAccessApi.md#emergency_access_id_delete)                                                                                                                                      | **DELETE** /emergency-access/{id}                                                        |
| _EmergencyAccessApi_                    | [**emergency_access_id_delete_post**](docs/EmergencyAccessApi.md#emergency_access_id_delete_post)                                                                                                                            | **POST** /emergency-access/{id}/delete                                                   |
| _EmergencyAccessApi_                    | [**emergency_access_id_get**](docs/EmergencyAccessApi.md#emergency_access_id_get)                                                                                                                                            | **GET** /emergency-access/{id}                                                           |
| _EmergencyAccessApi_                    | [**emergency_access_id_initiate_post**](docs/EmergencyAccessApi.md#emergency_access_id_initiate_post)                                                                                                                        | **POST** /emergency-access/{id}/initiate                                                 |
| _EmergencyAccessApi_                    | [**emergency_access_id_password_post**](docs/EmergencyAccessApi.md#emergency_access_id_password_post)                                                                                                                        | **POST** /emergency-access/{id}/password                                                 |
| _EmergencyAccessApi_                    | [**emergency_access_id_policies_get**](docs/EmergencyAccessApi.md#emergency_access_id_policies_get)                                                                                                                          | **GET** /emergency-access/{id}/policies                                                  |
| _EmergencyAccessApi_                    | [**emergency_access_id_post**](docs/EmergencyAccessApi.md#emergency_access_id_post)                                                                                                                                          | **POST** /emergency-access/{id}                                                          |
| _EmergencyAccessApi_                    | [**emergency_access_id_put**](docs/EmergencyAccessApi.md#emergency_access_id_put)                                                                                                                                            | **PUT** /emergency-access/{id}                                                           |
| _EmergencyAccessApi_                    | [**emergency_access_id_reinvite_post**](docs/EmergencyAccessApi.md#emergency_access_id_reinvite_post)                                                                                                                        | **POST** /emergency-access/{id}/reinvite                                                 |
| _EmergencyAccessApi_                    | [**emergency_access_id_reject_post**](docs/EmergencyAccessApi.md#emergency_access_id_reject_post)                                                                                                                            | **POST** /emergency-access/{id}/reject                                                   |
| _EmergencyAccessApi_                    | [**emergency_access_id_takeover_post**](docs/EmergencyAccessApi.md#emergency_access_id_takeover_post)                                                                                                                        | **POST** /emergency-access/{id}/takeover                                                 |
| _EmergencyAccessApi_                    | [**emergency_access_id_view_post**](docs/EmergencyAccessApi.md#emergency_access_id_view_post)                                                                                                                                | **POST** /emergency-access/{id}/view                                                     |
| _EmergencyAccessApi_                    | [**emergency_access_invite_post**](docs/EmergencyAccessApi.md#emergency_access_invite_post)                                                                                                                                  | **POST** /emergency-access/invite                                                        |
| _EmergencyAccessApi_                    | [**emergency_access_trusted_get**](docs/EmergencyAccessApi.md#emergency_access_trusted_get)                                                                                                                                  | **GET** /emergency-access/trusted                                                        |
| _EventsApi_                             | [**ciphers_id_events_get**](docs/EventsApi.md#ciphers_id_events_get)                                                                                                                                                         | **GET** /ciphers/{id}/events                                                             |
| _EventsApi_                             | [**events_get**](docs/EventsApi.md#events_get)                                                                                                                                                                               | **GET** /events                                                                          |
| _EventsApi_                             | [**organizations_id_events_get**](docs/EventsApi.md#organizations_id_events_get)                                                                                                                                             | **GET** /organizations/{id}/events                                                       |
| _EventsApi_                             | [**organizations_org_id_users_id_events_get**](docs/EventsApi.md#organizations_org_id_users_id_events_get)                                                                                                                   | **GET** /organizations/{orgId}/users/{id}/events                                         |
| _EventsApi_                             | [**providers_provider_id_events_get**](docs/EventsApi.md#providers_provider_id_events_get)                                                                                                                                   | **GET** /providers/{providerId}/events                                                   |
| _EventsApi_                             | [**providers_provider_id_users_id_events_get**](docs/EventsApi.md#providers_provider_id_users_id_events_get)                                                                                                                 | **GET** /providers/{providerId}/users/{id}/events                                        |
| _FoldersApi_                            | [**folders_get**](docs/FoldersApi.md#folders_get)                                                                                                                                                                            | **GET** /folders                                                                         |
| _FoldersApi_                            | [**folders_id_delete**](docs/FoldersApi.md#folders_id_delete)                                                                                                                                                                | **DELETE** /folders/{id}                                                                 |
| _FoldersApi_                            | [**folders_id_delete_post**](docs/FoldersApi.md#folders_id_delete_post)                                                                                                                                                      | **POST** /folders/{id}/delete                                                            |
| _FoldersApi_                            | [**folders_id_get**](docs/FoldersApi.md#folders_id_get)                                                                                                                                                                      | **GET** /folders/{id}                                                                    |
| _FoldersApi_                            | [**folders_id_post**](docs/FoldersApi.md#folders_id_post)                                                                                                                                                                    | **POST** /folders/{id}                                                                   |
| _FoldersApi_                            | [**folders_id_put**](docs/FoldersApi.md#folders_id_put)                                                                                                                                                                      | **PUT** /folders/{id}                                                                    |
| _FoldersApi_                            | [**folders_post**](docs/FoldersApi.md#folders_post)                                                                                                                                                                          | **POST** /folders                                                                        |
| _GroupsApi_                             | [**organizations_org_id_groups_delete**](docs/GroupsApi.md#organizations_org_id_groups_delete)                                                                                                                               | **DELETE** /organizations/{orgId}/groups                                                 |
| _GroupsApi_                             | [**organizations_org_id_groups_delete_post**](docs/GroupsApi.md#organizations_org_id_groups_delete_post)                                                                                                                     | **POST** /organizations/{orgId}/groups/delete                                            |
| _GroupsApi_                             | [**organizations_org_id_groups_get**](docs/GroupsApi.md#organizations_org_id_groups_get)                                                                                                                                     | **GET** /organizations/{orgId}/groups                                                    |
| _GroupsApi_                             | [**organizations_org_id_groups_id_delete**](docs/GroupsApi.md#organizations_org_id_groups_id_delete)                                                                                                                         | **DELETE** /organizations/{orgId}/groups/{id}                                            |
| _GroupsApi_                             | [**organizations_org_id_groups_id_delete_post**](docs/GroupsApi.md#organizations_org_id_groups_id_delete_post)                                                                                                               | **POST** /organizations/{orgId}/groups/{id}/delete                                       |
| _GroupsApi_                             | [**organizations_org_id_groups_id_delete_user_org_user_id_post**](docs/GroupsApi.md#organizations_org_id_groups_id_delete_user_org_user_id_post)                                                                             | **POST** /organizations/{orgId}/groups/{id}/delete-user/{orgUserId}                      |
| _GroupsApi_                             | [**organizations_org_id_groups_id_details_get**](docs/GroupsApi.md#organizations_org_id_groups_id_details_get)                                                                                                               | **GET** /organizations/{orgId}/groups/{id}/details                                       |
| _GroupsApi_                             | [**organizations_org_id_groups_id_get**](docs/GroupsApi.md#organizations_org_id_groups_id_get)                                                                                                                               | **GET** /organizations/{orgId}/groups/{id}                                               |
| _GroupsApi_                             | [**organizations_org_id_groups_id_post**](docs/GroupsApi.md#organizations_org_id_groups_id_post)                                                                                                                             | **POST** /organizations/{orgId}/groups/{id}                                              |
| _GroupsApi_                             | [**organizations_org_id_groups_id_put**](docs/GroupsApi.md#organizations_org_id_groups_id_put)                                                                                                                               | **PUT** /organizations/{orgId}/groups/{id}                                               |
| _GroupsApi_                             | [**organizations_org_id_groups_id_user_org_user_id_delete**](docs/GroupsApi.md#organizations_org_id_groups_id_user_org_user_id_delete)                                                                                       | **DELETE** /organizations/{orgId}/groups/{id}/user/{orgUserId}                           |
| _GroupsApi_                             | [**organizations_org_id_groups_id_users_get**](docs/GroupsApi.md#organizations_org_id_groups_id_users_get)                                                                                                                   | **GET** /organizations/{orgId}/groups/{id}/users                                         |
| _GroupsApi_                             | [**organizations_org_id_groups_post**](docs/GroupsApi.md#organizations_org_id_groups_post)                                                                                                                                   | **POST** /organizations/{orgId}/groups                                                   |
| _HibpApi_                               | [**hibp_breach_get**](docs/HibpApi.md#hibp_breach_get)                                                                                                                                                                       | **GET** /hibp/breach                                                                     |
| _ImportCiphersApi_                      | [**ciphers_import_organization_post**](docs/ImportCiphersApi.md#ciphers_import_organization_post)                                                                                                                            | **POST** /ciphers/import-organization                                                    |
| _ImportCiphersApi_                      | [**ciphers_import_post**](docs/ImportCiphersApi.md#ciphers_import_post)                                                                                                                                                      | **POST** /ciphers/import                                                                 |
| _InfoApi_                               | [**alive_get**](docs/InfoApi.md#alive_get)                                                                                                                                                                                   | **GET** /alive                                                                           |
| _InfoApi_                               | [**ip_get**](docs/InfoApi.md#ip_get)                                                                                                                                                                                         | **GET** /ip                                                                              |
| _InfoApi_                               | [**now_get**](docs/InfoApi.md#now_get)                                                                                                                                                                                       | **GET** /now                                                                             |
| _InfoApi_                               | [**version_get**](docs/InfoApi.md#version_get)                                                                                                                                                                               | **GET** /version                                                                         |
| _InstallationsApi_                      | [**installations_id_get**](docs/InstallationsApi.md#installations_id_get)                                                                                                                                                    | **GET** /installations/{id}                                                              |
| _InstallationsApi_                      | [**installations_post**](docs/InstallationsApi.md#installations_post)                                                                                                                                                        | **POST** /installations                                                                  |
| _LicensesApi_                           | [**licenses_organization_id_get**](docs/LicensesApi.md#licenses_organization_id_get)                                                                                                                                         | **GET** /licenses/organization/{id}                                                      | Used by self-hosted installations to get an updated license file |
| _LicensesApi_                           | [**licenses_user_id_get**](docs/LicensesApi.md#licenses_user_id_get)                                                                                                                                                         | **GET** /licenses/user/{id}                                                              |
| _MiscApi_                               | [**bitpay_invoice_post**](docs/MiscApi.md#bitpay_invoice_post)                                                                                                                                                               | **POST** /bitpay-invoice                                                                 |
| _MiscApi_                               | [**setup_payment_post**](docs/MiscApi.md#setup_payment_post)                                                                                                                                                                 | **POST** /setup-payment                                                                  |
| _OrganizationAuthRequestsApi_           | [**organizations_org_id_auth_requests_deny_post**](docs/OrganizationAuthRequestsApi.md#organizations_org_id_auth_requests_deny_post)                                                                                         | **POST** /organizations/{orgId}/auth-requests/deny                                       |
| _OrganizationAuthRequestsApi_           | [**organizations_org_id_auth_requests_get**](docs/OrganizationAuthRequestsApi.md#organizations_org_id_auth_requests_get)                                                                                                     | **GET** /organizations/{orgId}/auth-requests                                             |
| _OrganizationAuthRequestsApi_           | [**organizations_org_id_auth_requests_post**](docs/OrganizationAuthRequestsApi.md#organizations_org_id_auth_requests_post)                                                                                                   | **POST** /organizations/{orgId}/auth-requests                                            |
| _OrganizationAuthRequestsApi_           | [**organizations_org_id_auth_requests_request_id_post**](docs/OrganizationAuthRequestsApi.md#organizations_org_id_auth_requests_request_id_post)                                                                             | **POST** /organizations/{orgId}/auth-requests/{requestId}                                |
| _OrganizationBillingApi_                | [**organizations_organization_id_billing_get**](docs/OrganizationBillingApi.md#organizations_organization_id_billing_get)                                                                                                    | **GET** /organizations/{organizationId}/billing                                          |
| _OrganizationBillingApi_                | [**organizations_organization_id_billing_history_get**](docs/OrganizationBillingApi.md#organizations_organization_id_billing_history_get)                                                                                    | **GET** /organizations/{organizationId}/billing/history                                  |
| _OrganizationBillingApi_                | [**organizations_organization_id_billing_metadata_get**](docs/OrganizationBillingApi.md#organizations_organization_id_billing_metadata_get)                                                                                  | **GET** /organizations/{organizationId}/billing/metadata                                 |
| _OrganizationConnectionsApi_            | [**organizations_connections_enabled_get**](docs/OrganizationConnectionsApi.md#organizations_connections_enabled_get)                                                                                                        | **GET** /organizations/connections/enabled                                               |
| _OrganizationConnectionsApi_            | [**organizations_connections_organization_connection_id_delete**](docs/OrganizationConnectionsApi.md#organizations_connections_organization_connection_id_delete)                                                            | **DELETE** /organizations/connections/{organizationConnectionId}                         |
| _OrganizationConnectionsApi_            | [**organizations_connections_organization_connection_id_delete_post**](docs/OrganizationConnectionsApi.md#organizations_connections_organization_connection_id_delete_post)                                                  | **POST** /organizations/connections/{organizationConnectionId}/delete                    |
| _OrganizationConnectionsApi_            | [**organizations_connections_organization_connection_id_put**](docs/OrganizationConnectionsApi.md#organizations_connections_organization_connection_id_put)                                                                  | **PUT** /organizations/connections/{organizationConnectionId}                            |
| _OrganizationConnectionsApi_            | [**organizations_connections_organization_id_type_get**](docs/OrganizationConnectionsApi.md#organizations_connections_organization_id_type_get)                                                                              | **GET** /organizations/connections/{organizationId}/{type}                               |
| _OrganizationConnectionsApi_            | [**organizations_connections_post**](docs/OrganizationConnectionsApi.md#organizations_connections_post)                                                                                                                      | **POST** /organizations/connections                                                      |
| _OrganizationDomainApi_                 | [**organizations_domain_sso_details_post**](docs/OrganizationDomainApi.md#organizations_domain_sso_details_post)                                                                                                             | **POST** /organizations/domain/sso/details                                               |
| _OrganizationDomainApi_                 | [**organizations_org_id_domain_get**](docs/OrganizationDomainApi.md#organizations_org_id_domain_get)                                                                                                                         | **GET** /organizations/{orgId}/domain                                                    |
| _OrganizationDomainApi_                 | [**organizations_org_id_domain_id_delete**](docs/OrganizationDomainApi.md#organizations_org_id_domain_id_delete)                                                                                                             | **DELETE** /organizations/{orgId}/domain/{id}                                            |
| _OrganizationDomainApi_                 | [**organizations_org_id_domain_id_get**](docs/OrganizationDomainApi.md#organizations_org_id_domain_id_get)                                                                                                                   | **GET** /organizations/{orgId}/domain/{id}                                               |
| _OrganizationDomainApi_                 | [**organizations_org_id_domain_id_remove_post**](docs/OrganizationDomainApi.md#organizations_org_id_domain_id_remove_post)                                                                                                   | **POST** /organizations/{orgId}/domain/{id}/remove                                       |
| _OrganizationDomainApi_                 | [**organizations_org_id_domain_id_verify_post**](docs/OrganizationDomainApi.md#organizations_org_id_domain_id_verify_post)                                                                                                   | **POST** /organizations/{orgId}/domain/{id}/verify                                       |
| _OrganizationDomainApi_                 | [**organizations_org_id_domain_post**](docs/OrganizationDomainApi.md#organizations_org_id_domain_post)                                                                                                                       | **POST** /organizations/{orgId}/domain                                                   |
| _OrganizationExportApi_                 | [**organizations_organization_id_export_get**](docs/OrganizationExportApi.md#organizations_organization_id_export_get)                                                                                                       | **GET** /organizations/{organizationId}/export                                           |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_redeem_post**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_redeem_post)                                                                                                         | **POST** /organization/sponsorship/redeem                                                |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sponsored_sponsored_org_id_delete**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sponsored_sponsored_org_id_delete)                                                             | **DELETE** /organization/sponsorship/sponsored/{sponsoredOrgId}                          |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sponsored_sponsored_org_id_remove_post**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sponsored_sponsored_org_id_remove_post)                                                   | **POST** /organization/sponsorship/sponsored/{sponsoredOrgId}/remove                     |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sponsoring_org_id_families_for_enterprise_post**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sponsoring_org_id_families_for_enterprise_post)                                   | **POST** /organization/sponsorship/{sponsoringOrgId}/families-for-enterprise             |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sponsoring_org_id_families_for_enterprise_resend_post**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sponsoring_org_id_families_for_enterprise_resend_post)                     | **POST** /organization/sponsorship/{sponsoringOrgId}/families-for-enterprise/resend      |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sponsoring_org_id_sync_status_get**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sponsoring_org_id_sync_status_get)                                                             | **GET** /organization/sponsorship/{sponsoringOrgId}/sync-status                          |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sponsoring_organization_id_delete**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sponsoring_organization_id_delete)                                                             | **DELETE** /organization/sponsorship/{sponsoringOrganizationId}                          |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sponsoring_organization_id_delete_post**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sponsoring_organization_id_delete_post)                                                   | **POST** /organization/sponsorship/{sponsoringOrganizationId}/delete                     |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_sync_post**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_sync_post)                                                                                                             | **POST** /organization/sponsorship/sync                                                  |
| _OrganizationSponsorshipsApi_           | [**organization_sponsorship_validate_token_post**](docs/OrganizationSponsorshipsApi.md#organization_sponsorship_validate_token_post)                                                                                         | **POST** /organization/sponsorship/validate-token                                        |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_account_recovery_details_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_account_recovery_details_post)                                                                        | **POST** /organizations/{orgId}/users/account-recovery-details                           |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_confirm_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_confirm_post)                                                                                                          | **POST** /organizations/{orgId}/users/confirm                                            |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_delete**](docs/OrganizationUsersApi.md#organizations_org_id_users_delete)                                                                                                                      | **DELETE** /organizations/{orgId}/users                                                  |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_delete_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_delete_post)                                                                                                            | **POST** /organizations/{orgId}/users/delete                                             |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_enable_secrets_manager_patch**](docs/OrganizationUsersApi.md#organizations_org_id_users_enable_secrets_manager_patch)                                                                          | **PATCH** /organizations/{orgId}/users/enable-secrets-manager                            |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_enable_secrets_manager_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_enable_secrets_manager_put)                                                                              | **PUT** /organizations/{orgId}/users/enable-secrets-manager                              |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_get**](docs/OrganizationUsersApi.md#organizations_org_id_users_get)                                                                                                                            | **GET** /organizations/{orgId}/users                                                     |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_confirm_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_confirm_post)                                                                                                    | **POST** /organizations/{orgId}/users/{id}/confirm                                       |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_delete**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_delete)                                                                                                                | **DELETE** /organizations/{orgId}/users/{id}                                             |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_delete_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_delete_post)                                                                                                      | **POST** /organizations/{orgId}/users/{id}/delete                                        |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_get**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_get)                                                                                                                      | **GET** /organizations/{orgId}/users/{id}                                                |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_groups_get**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_groups_get)                                                                                                        | **GET** /organizations/{orgId}/users/{id}/groups                                         |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_post)                                                                                                                    | **POST** /organizations/{orgId}/users/{id}                                               |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_put)                                                                                                                      | **PUT** /organizations/{orgId}/users/{id}                                                |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_reinvite_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_reinvite_post)                                                                                                  | **POST** /organizations/{orgId}/users/{id}/reinvite                                      |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_reset_password_details_get**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_reset_password_details_get)                                                                        | **GET** /organizations/{orgId}/users/{id}/reset-password-details                         |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_reset_password_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_reset_password_put)                                                                                        | **PUT** /organizations/{orgId}/users/{id}/reset-password                                 |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_restore_patch**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_restore_patch)                                                                                                  | **PATCH** /organizations/{orgId}/users/{id}/restore                                      |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_restore_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_restore_put)                                                                                                      | **PUT** /organizations/{orgId}/users/{id}/restore                                        |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_revoke_patch**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_revoke_patch)                                                                                                    | **PATCH** /organizations/{orgId}/users/{id}/revoke                                       |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_id_revoke_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_id_revoke_put)                                                                                                        | **PUT** /organizations/{orgId}/users/{id}/revoke                                         |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_invite_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_invite_post)                                                                                                            | **POST** /organizations/{orgId}/users/invite                                             |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_organization_user_id_accept_init_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_organization_user_id_accept_init_post)                                                        | **POST** /organizations/{orgId}/users/{organizationUserId}/accept-init                   |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_organization_user_id_accept_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_organization_user_id_accept_post)                                                                  | **POST** /organizations/{orgId}/users/{organizationUserId}/accept                        |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_public_keys_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_public_keys_post)                                                                                                  | **POST** /organizations/{orgId}/users/public-keys                                        |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_reinvite_post**](docs/OrganizationUsersApi.md#organizations_org_id_users_reinvite_post)                                                                                                        | **POST** /organizations/{orgId}/users/reinvite                                           |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_restore_patch**](docs/OrganizationUsersApi.md#organizations_org_id_users_restore_patch)                                                                                                        | **PATCH** /organizations/{orgId}/users/restore                                           |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_restore_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_restore_put)                                                                                                            | **PUT** /organizations/{orgId}/users/restore                                             |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_revoke_patch**](docs/OrganizationUsersApi.md#organizations_org_id_users_revoke_patch)                                                                                                          | **PATCH** /organizations/{orgId}/users/revoke                                            |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_revoke_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_revoke_put)                                                                                                              | **PUT** /organizations/{orgId}/users/revoke                                              |
| _OrganizationUsersApi_                  | [**organizations_org_id_users_user_id_reset_password_enrollment_put**](docs/OrganizationUsersApi.md#organizations_org_id_users_user_id_reset_password_enrollment_put)                                                        | **PUT** /organizations/{orgId}/users/{userId}/reset-password-enrollment                  |
| _OrganizationsApi_                      | [**organizations_get**](docs/OrganizationsApi.md#organizations_get)                                                                                                                                                          | **GET** /organizations                                                                   |
| _OrganizationsApi_                      | [**organizations_id_api_key_information_type_get**](docs/OrganizationsApi.md#organizations_id_api_key_information_type_get)                                                                                                  | **GET** /organizations/{id}/api-key-information/{type}                                   |
| _OrganizationsApi_                      | [**organizations_id_api_key_post**](docs/OrganizationsApi.md#organizations_id_api_key_post)                                                                                                                                  | **POST** /organizations/{id}/api-key                                                     |
| _OrganizationsApi_                      | [**organizations_id_billing_status_get**](docs/OrganizationsApi.md#organizations_id_billing_status_get)                                                                                                                      | **GET** /organizations/{id}/billing-status                                               |
| _OrganizationsApi_                      | [**organizations_id_cancel_post**](docs/OrganizationsApi.md#organizations_id_cancel_post)                                                                                                                                    | **POST** /organizations/{id}/cancel                                                      |
| _OrganizationsApi_                      | [**organizations_id_collection_management_put**](docs/OrganizationsApi.md#organizations_id_collection_management_put)                                                                                                        | **PUT** /organizations/{id}/collection-management                                        |
| _OrganizationsApi_                      | [**organizations_id_delete**](docs/OrganizationsApi.md#organizations_id_delete)                                                                                                                                              | **DELETE** /organizations/{id}                                                           |
| _OrganizationsApi_                      | [**organizations_id_delete_post**](docs/OrganizationsApi.md#organizations_id_delete_post)                                                                                                                                    | **POST** /organizations/{id}/delete                                                      |
| _OrganizationsApi_                      | [**organizations_id_delete_recover_token_post**](docs/OrganizationsApi.md#organizations_id_delete_recover_token_post)                                                                                                        | **POST** /organizations/{id}/delete-recover-token                                        |
| _OrganizationsApi_                      | [**organizations_id_get**](docs/OrganizationsApi.md#organizations_id_get)                                                                                                                                                    | **GET** /organizations/{id}                                                              |
| _OrganizationsApi_                      | [**organizations_id_import_post**](docs/OrganizationsApi.md#organizations_id_import_post)                                                                                                                                    | **POST** /organizations/{id}/import                                                      |
| _OrganizationsApi_                      | [**organizations_id_keys_get**](docs/OrganizationsApi.md#organizations_id_keys_get)                                                                                                                                          | **GET** /organizations/{id}/keys                                                         |
| _OrganizationsApi_                      | [**organizations_id_keys_post**](docs/OrganizationsApi.md#organizations_id_keys_post)                                                                                                                                        | **POST** /organizations/{id}/keys                                                        |
| _OrganizationsApi_                      | [**organizations_id_leave_post**](docs/OrganizationsApi.md#organizations_id_leave_post)                                                                                                                                      | **POST** /organizations/{id}/leave                                                       |
| _OrganizationsApi_                      | [**organizations_id_license_get**](docs/OrganizationsApi.md#organizations_id_license_get)                                                                                                                                    | **GET** /organizations/{id}/license                                                      |
| _OrganizationsApi_                      | [**organizations_id_payment_post**](docs/OrganizationsApi.md#organizations_id_payment_post)                                                                                                                                  | **POST** /organizations/{id}/payment                                                     |
| _OrganizationsApi_                      | [**organizations_id_post**](docs/OrganizationsApi.md#organizations_id_post)                                                                                                                                                  | **POST** /organizations/{id}                                                             |
| _OrganizationsApi_                      | [**organizations_id_public_key_get**](docs/OrganizationsApi.md#organizations_id_public_key_get)                                                                                                                              | **GET** /organizations/{id}/public-key                                                   |
| _OrganizationsApi_                      | [**organizations_id_put**](docs/OrganizationsApi.md#organizations_id_put)                                                                                                                                                    | **PUT** /organizations/{id}                                                              |
| _OrganizationsApi_                      | [**organizations_id_reinstate_post**](docs/OrganizationsApi.md#organizations_id_reinstate_post)                                                                                                                              | **POST** /organizations/{id}/reinstate                                                   |
| _OrganizationsApi_                      | [**organizations_id_rotate_api_key_post**](docs/OrganizationsApi.md#organizations_id_rotate_api_key_post)                                                                                                                    | **POST** /organizations/{id}/rotate-api-key                                              |
| _OrganizationsApi_                      | [**organizations_id_seat_post**](docs/OrganizationsApi.md#organizations_id_seat_post)                                                                                                                                        | **POST** /organizations/{id}/seat                                                        |
| _OrganizationsApi_                      | [**organizations_id_sm_subscription_post**](docs/OrganizationsApi.md#organizations_id_sm_subscription_post)                                                                                                                  | **POST** /organizations/{id}/sm-subscription                                             |
| _OrganizationsApi_                      | [**organizations_id_sso_get**](docs/OrganizationsApi.md#organizations_id_sso_get)                                                                                                                                            | **GET** /organizations/{id}/sso                                                          |
| _OrganizationsApi_                      | [**organizations_id_sso_post**](docs/OrganizationsApi.md#organizations_id_sso_post)                                                                                                                                          | **POST** /organizations/{id}/sso                                                         |
| _OrganizationsApi_                      | [**organizations_id_storage_post**](docs/OrganizationsApi.md#organizations_id_storage_post)                                                                                                                                  | **POST** /organizations/{id}/storage                                                     |
| _OrganizationsApi_                      | [**organizations_id_subscribe_secrets_manager_post**](docs/OrganizationsApi.md#organizations_id_subscribe_secrets_manager_post)                                                                                              | **POST** /organizations/{id}/subscribe-secrets-manager                                   |
| _OrganizationsApi_                      | [**organizations_id_subscription_get**](docs/OrganizationsApi.md#organizations_id_subscription_get)                                                                                                                          | **GET** /organizations/{id}/subscription                                                 |
| _OrganizationsApi_                      | [**organizations_id_subscription_post**](docs/OrganizationsApi.md#organizations_id_subscription_post)                                                                                                                        | **POST** /organizations/{id}/subscription                                                |
| _OrganizationsApi_                      | [**organizations_id_tax_get**](docs/OrganizationsApi.md#organizations_id_tax_get)                                                                                                                                            | **GET** /organizations/{id}/tax                                                          |
| _OrganizationsApi_                      | [**organizations_id_tax_put**](docs/OrganizationsApi.md#organizations_id_tax_put)                                                                                                                                            | **PUT** /organizations/{id}/tax                                                          |
| _OrganizationsApi_                      | [**organizations_id_upgrade_post**](docs/OrganizationsApi.md#organizations_id_upgrade_post)                                                                                                                                  | **POST** /organizations/{id}/upgrade                                                     |
| _OrganizationsApi_                      | [**organizations_id_verify_bank_post**](docs/OrganizationsApi.md#organizations_id_verify_bank_post)                                                                                                                          | **POST** /organizations/{id}/verify-bank                                                 |
| _OrganizationsApi_                      | [**organizations_identifier_auto_enroll_status_get**](docs/OrganizationsApi.md#organizations_identifier_auto_enroll_status_get)                                                                                              | **GET** /organizations/{identifier}/auto-enroll-status                                   |
| _OrganizationsApi_                      | [**organizations_post**](docs/OrganizationsApi.md#organizations_post)                                                                                                                                                        | **POST** /organizations                                                                  |
| _PlansApi_                              | [**plans_get**](docs/PlansApi.md#plans_get)                                                                                                                                                                                  | **GET** /plans                                                                           |
| _PlansApi_                              | [**plans_sales_tax_rates_get**](docs/PlansApi.md#plans_sales_tax_rates_get)                                                                                                                                                  | **GET** /plans/sales-tax-rates                                                           |
| _PoliciesApi_                           | [**organizations_org_id_policies_get**](docs/PoliciesApi.md#organizations_org_id_policies_get)                                                                                                                               | **GET** /organizations/{orgId}/policies                                                  |
| _PoliciesApi_                           | [**organizations_org_id_policies_invited_user_get**](docs/PoliciesApi.md#organizations_org_id_policies_invited_user_get)                                                                                                     | **GET** /organizations/{orgId}/policies/invited-user                                     |
| _PoliciesApi_                           | [**organizations_org_id_policies_master_password_get**](docs/PoliciesApi.md#organizations_org_id_policies_master_password_get)                                                                                               | **GET** /organizations/{orgId}/policies/master-password                                  |
| _PoliciesApi_                           | [**organizations_org_id_policies_token_get**](docs/PoliciesApi.md#organizations_org_id_policies_token_get)                                                                                                                   | **GET** /organizations/{orgId}/policies/token                                            |
| _PoliciesApi_                           | [**organizations_org_id_policies_type_get**](docs/PoliciesApi.md#organizations_org_id_policies_type_get)                                                                                                                     | **GET** /organizations/{orgId}/policies/{type}                                           |
| _PoliciesApi_                           | [**organizations_org_id_policies_type_put**](docs/PoliciesApi.md#organizations_org_id_policies_type_put)                                                                                                                     | **PUT** /organizations/{orgId}/policies/{type}                                           |
| _ProjectsApi_                           | [**organizations_organization_id_projects_get**](docs/ProjectsApi.md#organizations_organization_id_projects_get)                                                                                                             | **GET** /organizations/{organizationId}/projects                                         |
| _ProjectsApi_                           | [**organizations_organization_id_projects_post**](docs/ProjectsApi.md#organizations_organization_id_projects_post)                                                                                                           | **POST** /organizations/{organizationId}/projects                                        |
| _ProjectsApi_                           | [**projects_delete_post**](docs/ProjectsApi.md#projects_delete_post)                                                                                                                                                         | **POST** /projects/delete                                                                |
| _ProjectsApi_                           | [**projects_id_get**](docs/ProjectsApi.md#projects_id_get)                                                                                                                                                                   | **GET** /projects/{id}                                                                   |
| _ProjectsApi_                           | [**projects_id_put**](docs/ProjectsApi.md#projects_id_put)                                                                                                                                                                   | **PUT** /projects/{id}                                                                   |
| _ProviderBillingApi_                    | [**providers_provider_id_billing_invoices_get**](docs/ProviderBillingApi.md#providers_provider_id_billing_invoices_get)                                                                                                      | **GET** /providers/{providerId}/billing/invoices                                         |
| _ProviderBillingApi_                    | [**providers_provider_id_billing_invoices_invoice_id_get**](docs/ProviderBillingApi.md#providers_provider_id_billing_invoices_invoice_id_get)                                                                                | **GET** /providers/{providerId}/billing/invoices/{invoiceId}                             |
| _ProviderBillingApi_                    | [**providers_provider_id_billing_subscription_get**](docs/ProviderBillingApi.md#providers_provider_id_billing_subscription_get)                                                                                              | **GET** /providers/{providerId}/billing/subscription                                     |
| _ProviderBillingApi_                    | [**providers_provider_id_billing_tax_information_put**](docs/ProviderBillingApi.md#providers_provider_id_billing_tax_information_put)                                                                                        | **PUT** /providers/{providerId}/billing/tax-information                                  |
| _ProviderClientsApi_                    | [**providers_provider_id_clients_post**](docs/ProviderClientsApi.md#providers_provider_id_clients_post)                                                                                                                      | **POST** /providers/{providerId}/clients                                                 |
| _ProviderClientsApi_                    | [**providers_provider_id_clients_provider_organization_id_put**](docs/ProviderClientsApi.md#providers_provider_id_clients_provider_organization_id_put)                                                                      | **PUT** /providers/{providerId}/clients/{providerOrganizationId}                         |
| _ProviderOrganizationsApi_              | [**providers_provider_id_organizations_add_post**](docs/ProviderOrganizationsApi.md#providers_provider_id_organizations_add_post)                                                                                            | **POST** /providers/{providerId}/organizations/add                                       |
| _ProviderOrganizationsApi_              | [**providers_provider_id_organizations_get**](docs/ProviderOrganizationsApi.md#providers_provider_id_organizations_get)                                                                                                      | **GET** /providers/{providerId}/organizations                                            |
| _ProviderOrganizationsApi_              | [**providers_provider_id_organizations_id_delete**](docs/ProviderOrganizationsApi.md#providers_provider_id_organizations_id_delete)                                                                                          | **DELETE** /providers/{providerId}/organizations/{id}                                    |
| _ProviderOrganizationsApi_              | [**providers_provider_id_organizations_id_delete_post**](docs/ProviderOrganizationsApi.md#providers_provider_id_organizations_id_delete_post)                                                                                | **POST** /providers/{providerId}/organizations/{id}/delete                               |
| _ProviderOrganizationsApi_              | [**providers_provider_id_organizations_post**](docs/ProviderOrganizationsApi.md#providers_provider_id_organizations_post)                                                                                                    | **POST** /providers/{providerId}/organizations                                           |
| _ProviderUsersApi_                      | [**providers_provider_id_users_confirm_post**](docs/ProviderUsersApi.md#providers_provider_id_users_confirm_post)                                                                                                            | **POST** /providers/{providerId}/users/confirm                                           |
| _ProviderUsersApi_                      | [**providers_provider_id_users_delete**](docs/ProviderUsersApi.md#providers_provider_id_users_delete)                                                                                                                        | **DELETE** /providers/{providerId}/users                                                 |
| _ProviderUsersApi_                      | [**providers_provider_id_users_delete_post**](docs/ProviderUsersApi.md#providers_provider_id_users_delete_post)                                                                                                              | **POST** /providers/{providerId}/users/delete                                            |
| _ProviderUsersApi_                      | [**providers_provider_id_users_get**](docs/ProviderUsersApi.md#providers_provider_id_users_get)                                                                                                                              | **GET** /providers/{providerId}/users                                                    |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_accept_post**](docs/ProviderUsersApi.md#providers_provider_id_users_id_accept_post)                                                                                                        | **POST** /providers/{providerId}/users/{id}/accept                                       |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_confirm_post**](docs/ProviderUsersApi.md#providers_provider_id_users_id_confirm_post)                                                                                                      | **POST** /providers/{providerId}/users/{id}/confirm                                      |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_delete**](docs/ProviderUsersApi.md#providers_provider_id_users_id_delete)                                                                                                                  | **DELETE** /providers/{providerId}/users/{id}                                            |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_delete_post**](docs/ProviderUsersApi.md#providers_provider_id_users_id_delete_post)                                                                                                        | **POST** /providers/{providerId}/users/{id}/delete                                       |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_get**](docs/ProviderUsersApi.md#providers_provider_id_users_id_get)                                                                                                                        | **GET** /providers/{providerId}/users/{id}                                               |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_post**](docs/ProviderUsersApi.md#providers_provider_id_users_id_post)                                                                                                                      | **POST** /providers/{providerId}/users/{id}                                              |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_put**](docs/ProviderUsersApi.md#providers_provider_id_users_id_put)                                                                                                                        | **PUT** /providers/{providerId}/users/{id}                                               |
| _ProviderUsersApi_                      | [**providers_provider_id_users_id_reinvite_post**](docs/ProviderUsersApi.md#providers_provider_id_users_id_reinvite_post)                                                                                                    | **POST** /providers/{providerId}/users/{id}/reinvite                                     |
| _ProviderUsersApi_                      | [**providers_provider_id_users_invite_post**](docs/ProviderUsersApi.md#providers_provider_id_users_invite_post)                                                                                                              | **POST** /providers/{providerId}/users/invite                                            |
| _ProviderUsersApi_                      | [**providers_provider_id_users_public_keys_post**](docs/ProviderUsersApi.md#providers_provider_id_users_public_keys_post)                                                                                                    | **POST** /providers/{providerId}/users/public-keys                                       |
| _ProviderUsersApi_                      | [**providers_provider_id_users_reinvite_post**](docs/ProviderUsersApi.md#providers_provider_id_users_reinvite_post)                                                                                                          | **POST** /providers/{providerId}/users/reinvite                                          |
| _ProvidersApi_                          | [**providers_id_delete**](docs/ProvidersApi.md#providers_id_delete)                                                                                                                                                          | **DELETE** /providers/{id}                                                               |
| _ProvidersApi_                          | [**providers_id_delete_post**](docs/ProvidersApi.md#providers_id_delete_post)                                                                                                                                                | **POST** /providers/{id}/delete                                                          |
| _ProvidersApi_                          | [**providers_id_delete_recover_token_post**](docs/ProvidersApi.md#providers_id_delete_recover_token_post)                                                                                                                    | **POST** /providers/{id}/delete-recover-token                                            |
| _ProvidersApi_                          | [**providers_id_get**](docs/ProvidersApi.md#providers_id_get)                                                                                                                                                                | **GET** /providers/{id}                                                                  |
| _ProvidersApi_                          | [**providers_id_post**](docs/ProvidersApi.md#providers_id_post)                                                                                                                                                              | **POST** /providers/{id}                                                                 |
| _ProvidersApi_                          | [**providers_id_put**](docs/ProvidersApi.md#providers_id_put)                                                                                                                                                                | **PUT** /providers/{id}                                                                  |
| _ProvidersApi_                          | [**providers_id_setup_post**](docs/ProvidersApi.md#providers_id_setup_post)                                                                                                                                                  | **POST** /providers/{id}/setup                                                           |
| _PushApi_                               | [**push_add_organization_put**](docs/PushApi.md#push_add_organization_put)                                                                                                                                                   | **PUT** /push/add-organization                                                           |
| _PushApi_                               | [**push_delete_organization_put**](docs/PushApi.md#push_delete_organization_put)                                                                                                                                             | **PUT** /push/delete-organization                                                        |
| _PushApi_                               | [**push_delete_post**](docs/PushApi.md#push_delete_post)                                                                                                                                                                     | **POST** /push/delete                                                                    |
| _PushApi_                               | [**push_register_post**](docs/PushApi.md#push_register_post)                                                                                                                                                                 | **POST** /push/register                                                                  |
| _PushApi_                               | [**push_send_post**](docs/PushApi.md#push_send_post)                                                                                                                                                                         | **POST** /push/send                                                                      |
| _RequestSmAccessApi_                    | [**request_access_request_sm_access_post**](docs/RequestSmAccessApi.md#request_access_request_sm_access_post)                                                                                                                | **POST** /request-access/request-sm-access                                               |
| _SecretsApi_                            | [**organizations_organization_id_secrets_get**](docs/SecretsApi.md#organizations_organization_id_secrets_get)                                                                                                                | **GET** /organizations/{organizationId}/secrets                                          |
| _SecretsApi_                            | [**organizations_organization_id_secrets_post**](docs/SecretsApi.md#organizations_organization_id_secrets_post)                                                                                                              | **POST** /organizations/{organizationId}/secrets                                         |
| _SecretsApi_                            | [**organizations_organization_id_secrets_sync_get**](docs/SecretsApi.md#organizations_organization_id_secrets_sync_get)                                                                                                      | **GET** /organizations/{organizationId}/secrets/sync                                     |
| _SecretsApi_                            | [**projects_project_id_secrets_get**](docs/SecretsApi.md#projects_project_id_secrets_get)                                                                                                                                    | **GET** /projects/{projectId}/secrets                                                    |
| _SecretsApi_                            | [**secrets_delete_post**](docs/SecretsApi.md#secrets_delete_post)                                                                                                                                                            | **POST** /secrets/delete                                                                 |
| _SecretsApi_                            | [**secrets_get_by_ids_post**](docs/SecretsApi.md#secrets_get_by_ids_post)                                                                                                                                                    | **POST** /secrets/get-by-ids                                                             |
| _SecretsApi_                            | [**secrets_id_get**](docs/SecretsApi.md#secrets_id_get)                                                                                                                                                                      | **GET** /secrets/{id}                                                                    |
| _SecretsApi_                            | [**secrets_id_put**](docs/SecretsApi.md#secrets_id_put)                                                                                                                                                                      | **PUT** /secrets/{id}                                                                    |
| _SecretsManagerEventsApi_               | [**sm_events_service_accounts_service_account_id_get**](docs/SecretsManagerEventsApi.md#sm_events_service_accounts_service_account_id_get)                                                                                   | **GET** /sm/events/service-accounts/{serviceAccountId}                                   |
| _SecretsManagerPortingApi_              | [**sm_organization_id_export_get**](docs/SecretsManagerPortingApi.md#sm_organization_id_export_get)                                                                                                                          | **GET** /sm/{organizationId}/export                                                      |
| _SecretsManagerPortingApi_              | [**sm_organization_id_import_post**](docs/SecretsManagerPortingApi.md#sm_organization_id_import_post)                                                                                                                        | **POST** /sm/{organizationId}/import                                                     |
| _SelfHostedOrganizationLicensesApi_     | [**organizations_licenses_self_hosted_id_post**](docs/SelfHostedOrganizationLicensesApi.md#organizations_licenses_self_hosted_id_post)                                                                                       | **POST** /organizations/licenses/self-hosted/{id}                                        |
| _SelfHostedOrganizationLicensesApi_     | [**organizations_licenses_self_hosted_id_sync_post**](docs/SelfHostedOrganizationLicensesApi.md#organizations_licenses_self_hosted_id_sync_post)                                                                             | **POST** /organizations/licenses/self-hosted/{id}/sync                                   |
| _SelfHostedOrganizationLicensesApi_     | [**organizations_licenses_self_hosted_post**](docs/SelfHostedOrganizationLicensesApi.md#organizations_licenses_self_hosted_post)                                                                                             | **POST** /organizations/licenses/self-hosted                                             |
| _SelfHostedOrganizationSponsorshipsApi_ | [**organization_sponsorship_self_hosted_sponsoring_org_id_delete**](docs/SelfHostedOrganizationSponsorshipsApi.md#organization_sponsorship_self_hosted_sponsoring_org_id_delete)                                             | **DELETE** /organization/sponsorship/self-hosted/{sponsoringOrgId}                       |
| _SelfHostedOrganizationSponsorshipsApi_ | [**organization_sponsorship_self_hosted_sponsoring_org_id_delete_post**](docs/SelfHostedOrganizationSponsorshipsApi.md#organization_sponsorship_self_hosted_sponsoring_org_id_delete_post)                                   | **POST** /organization/sponsorship/self-hosted/{sponsoringOrgId}/delete                  |
| _SelfHostedOrganizationSponsorshipsApi_ | [**organization_sponsorship_self_hosted_sponsoring_org_id_families_for_enterprise_post**](docs/SelfHostedOrganizationSponsorshipsApi.md#organization_sponsorship_self_hosted_sponsoring_org_id_families_for_enterprise_post) | **POST** /organization/sponsorship/self-hosted/{sponsoringOrgId}/families-for-enterprise |
| _SendsApi_                              | [**sends_access_id_post**](docs/SendsApi.md#sends_access_id_post)                                                                                                                                                            | **POST** /sends/access/{id}                                                              |
| _SendsApi_                              | [**sends_encoded_send_id_access_file_file_id_post**](docs/SendsApi.md#sends_encoded_send_id_access_file_file_id_post)                                                                                                        | **POST** /sends/{encodedSendId}/access/file/{fileId}                                     |
| _SendsApi_                              | [**sends_file_post**](docs/SendsApi.md#sends_file_post)                                                                                                                                                                      | **POST** /sends/file                                                                     |
| _SendsApi_                              | [**sends_file_v2_post**](docs/SendsApi.md#sends_file_v2_post)                                                                                                                                                                | **POST** /sends/file/v2                                                                  |
| _SendsApi_                              | [**sends_file_validate_azure_post**](docs/SendsApi.md#sends_file_validate_azure_post)                                                                                                                                        | **POST** /sends/file/validate/azure                                                      |
| _SendsApi_                              | [**sends_get**](docs/SendsApi.md#sends_get)                                                                                                                                                                                  | **GET** /sends                                                                           |
| _SendsApi_                              | [**sends_id_delete**](docs/SendsApi.md#sends_id_delete)                                                                                                                                                                      | **DELETE** /sends/{id}                                                                   |
| _SendsApi_                              | [**sends_id_file_file_id_get**](docs/SendsApi.md#sends_id_file_file_id_get)                                                                                                                                                  | **GET** /sends/{id}/file/{fileId}                                                        |
| _SendsApi_                              | [**sends_id_file_file_id_post**](docs/SendsApi.md#sends_id_file_file_id_post)                                                                                                                                                | **POST** /sends/{id}/file/{fileId}                                                       |
| _SendsApi_                              | [**sends_id_get**](docs/SendsApi.md#sends_id_get)                                                                                                                                                                            | **GET** /sends/{id}                                                                      |
| _SendsApi_                              | [**sends_id_put**](docs/SendsApi.md#sends_id_put)                                                                                                                                                                            | **PUT** /sends/{id}                                                                      |
| _SendsApi_                              | [**sends_id_remove_password_put**](docs/SendsApi.md#sends_id_remove_password_put)                                                                                                                                            | **PUT** /sends/{id}/remove-password                                                      |
| _SendsApi_                              | [**sends_post**](docs/SendsApi.md#sends_post)                                                                                                                                                                                | **POST** /sends                                                                          |
| _ServiceAccountsApi_                    | [**organizations_organization_id_service_accounts_get**](docs/ServiceAccountsApi.md#organizations_organization_id_service_accounts_get)                                                                                      | **GET** /organizations/{organizationId}/service-accounts                                 |
| _ServiceAccountsApi_                    | [**organizations_organization_id_service_accounts_post**](docs/ServiceAccountsApi.md#organizations_organization_id_service_accounts_post)                                                                                    | **POST** /organizations/{organizationId}/service-accounts                                |
| _ServiceAccountsApi_                    | [**service_accounts_delete_post**](docs/ServiceAccountsApi.md#service_accounts_delete_post)                                                                                                                                  | **POST** /service-accounts/delete                                                        |
| _ServiceAccountsApi_                    | [**service_accounts_id_access_tokens_get**](docs/ServiceAccountsApi.md#service_accounts_id_access_tokens_get)                                                                                                                | **GET** /service-accounts/{id}/access-tokens                                             |
| _ServiceAccountsApi_                    | [**service_accounts_id_access_tokens_post**](docs/ServiceAccountsApi.md#service_accounts_id_access_tokens_post)                                                                                                              | **POST** /service-accounts/{id}/access-tokens                                            |
| _ServiceAccountsApi_                    | [**service_accounts_id_access_tokens_revoke_post**](docs/ServiceAccountsApi.md#service_accounts_id_access_tokens_revoke_post)                                                                                                | **POST** /service-accounts/{id}/access-tokens/revoke                                     |
| _ServiceAccountsApi_                    | [**service_accounts_id_get**](docs/ServiceAccountsApi.md#service_accounts_id_get)                                                                                                                                            | **GET** /service-accounts/{id}                                                           |
| _ServiceAccountsApi_                    | [**service_accounts_id_put**](docs/ServiceAccountsApi.md#service_accounts_id_put)                                                                                                                                            | **PUT** /service-accounts/{id}                                                           |
| _SettingsApi_                           | [**settings_domains_get**](docs/SettingsApi.md#settings_domains_get)                                                                                                                                                         | **GET** /settings/domains                                                                |
| _SettingsApi_                           | [**settings_domains_post**](docs/SettingsApi.md#settings_domains_post)                                                                                                                                                       | **POST** /settings/domains                                                               |
| _SettingsApi_                           | [**settings_domains_put**](docs/SettingsApi.md#settings_domains_put)                                                                                                                                                         | **PUT** /settings/domains                                                                |
| _StripeApi_                             | [**setup_intent_bank_account_post**](docs/StripeApi.md#setup_intent_bank_account_post)                                                                                                                                       | **POST** /setup-intent/bank-account                                                      |
| _StripeApi_                             | [**setup_intent_card_post**](docs/StripeApi.md#setup_intent_card_post)                                                                                                                                                       | **POST** /setup-intent/card                                                              |
| _SyncApi_                               | [**sync_get**](docs/SyncApi.md#sync_get)                                                                                                                                                                                     | **GET** /sync                                                                            |
| _TrashApi_                              | [**secrets_organization_id_trash_empty_post**](docs/TrashApi.md#secrets_organization_id_trash_empty_post)                                                                                                                    | **POST** /secrets/{organizationId}/trash/empty                                           |
| _TrashApi_                              | [**secrets_organization_id_trash_get**](docs/TrashApi.md#secrets_organization_id_trash_get)                                                                                                                                  | **GET** /secrets/{organizationId}/trash                                                  |
| _TrashApi_                              | [**secrets_organization_id_trash_restore_post**](docs/TrashApi.md#secrets_organization_id_trash_restore_post)                                                                                                                | **POST** /secrets/{organizationId}/trash/restore                                         |
| _TwoFactorApi_                          | [**organizations_id_two_factor_disable_post**](docs/TwoFactorApi.md#organizations_id_two_factor_disable_post)                                                                                                                | **POST** /organizations/{id}/two-factor/disable                                          |
| _TwoFactorApi_                          | [**organizations_id_two_factor_disable_put**](docs/TwoFactorApi.md#organizations_id_two_factor_disable_put)                                                                                                                  | **PUT** /organizations/{id}/two-factor/disable                                           |
| _TwoFactorApi_                          | [**organizations_id_two_factor_duo_post**](docs/TwoFactorApi.md#organizations_id_two_factor_duo_post)                                                                                                                        | **POST** /organizations/{id}/two-factor/duo                                              |
| _TwoFactorApi_                          | [**organizations_id_two_factor_duo_put**](docs/TwoFactorApi.md#organizations_id_two_factor_duo_put)                                                                                                                          | **PUT** /organizations/{id}/two-factor/duo                                               |
| _TwoFactorApi_                          | [**organizations_id_two_factor_get**](docs/TwoFactorApi.md#organizations_id_two_factor_get)                                                                                                                                  | **GET** /organizations/{id}/two-factor                                                   |
| _TwoFactorApi_                          | [**organizations_id_two_factor_get_duo_post**](docs/TwoFactorApi.md#organizations_id_two_factor_get_duo_post)                                                                                                                | **POST** /organizations/{id}/two-factor/get-duo                                          |
| _TwoFactorApi_                          | [**two_factor_authenticator_delete**](docs/TwoFactorApi.md#two_factor_authenticator_delete)                                                                                                                                  | **DELETE** /two-factor/authenticator                                                     |
| _TwoFactorApi_                          | [**two_factor_authenticator_post**](docs/TwoFactorApi.md#two_factor_authenticator_post)                                                                                                                                      | **POST** /two-factor/authenticator                                                       |
| _TwoFactorApi_                          | [**two_factor_authenticator_put**](docs/TwoFactorApi.md#two_factor_authenticator_put)                                                                                                                                        | **PUT** /two-factor/authenticator                                                        |
| _TwoFactorApi_                          | [**two_factor_device_verification_settings_put**](docs/TwoFactorApi.md#two_factor_device_verification_settings_put)                                                                                                          | **PUT** /two-factor/device-verification-settings                                         |
| _TwoFactorApi_                          | [**two_factor_disable_post**](docs/TwoFactorApi.md#two_factor_disable_post)                                                                                                                                                  | **POST** /two-factor/disable                                                             |
| _TwoFactorApi_                          | [**two_factor_disable_put**](docs/TwoFactorApi.md#two_factor_disable_put)                                                                                                                                                    | **PUT** /two-factor/disable                                                              |
| _TwoFactorApi_                          | [**two_factor_duo_post**](docs/TwoFactorApi.md#two_factor_duo_post)                                                                                                                                                          | **POST** /two-factor/duo                                                                 |
| _TwoFactorApi_                          | [**two_factor_duo_put**](docs/TwoFactorApi.md#two_factor_duo_put)                                                                                                                                                            | **PUT** /two-factor/duo                                                                  |
| _TwoFactorApi_                          | [**two_factor_email_post**](docs/TwoFactorApi.md#two_factor_email_post)                                                                                                                                                      | **POST** /two-factor/email                                                               |
| _TwoFactorApi_                          | [**two_factor_email_put**](docs/TwoFactorApi.md#two_factor_email_put)                                                                                                                                                        | **PUT** /two-factor/email                                                                |
| _TwoFactorApi_                          | [**two_factor_get**](docs/TwoFactorApi.md#two_factor_get)                                                                                                                                                                    | **GET** /two-factor                                                                      |
| _TwoFactorApi_                          | [**two_factor_get_authenticator_post**](docs/TwoFactorApi.md#two_factor_get_authenticator_post)                                                                                                                              | **POST** /two-factor/get-authenticator                                                   |
| _TwoFactorApi_                          | [**two_factor_get_device_verification_settings_get**](docs/TwoFactorApi.md#two_factor_get_device_verification_settings_get)                                                                                                  | **GET** /two-factor/get-device-verification-settings                                     |
| _TwoFactorApi_                          | [**two_factor_get_duo_post**](docs/TwoFactorApi.md#two_factor_get_duo_post)                                                                                                                                                  | **POST** /two-factor/get-duo                                                             |
| _TwoFactorApi_                          | [**two_factor_get_email_post**](docs/TwoFactorApi.md#two_factor_get_email_post)                                                                                                                                              | **POST** /two-factor/get-email                                                           |
| _TwoFactorApi_                          | [**two_factor_get_recover_post**](docs/TwoFactorApi.md#two_factor_get_recover_post)                                                                                                                                          | **POST** /two-factor/get-recover                                                         |
| _TwoFactorApi_                          | [**two_factor_get_webauthn_post**](docs/TwoFactorApi.md#two_factor_get_webauthn_post)                                                                                                                                        | **POST** /two-factor/get-webauthn                                                        |
| _TwoFactorApi_                          | [**two_factor_get_yubikey_post**](docs/TwoFactorApi.md#two_factor_get_yubikey_post)                                                                                                                                          | **POST** /two-factor/get-yubikey                                                         |
| _TwoFactorApi_                          | [**two_factor_recover_post**](docs/TwoFactorApi.md#two_factor_recover_post)                                                                                                                                                  | **POST** /two-factor/recover                                                             |
| _TwoFactorApi_                          | [**two_factor_send_email_login_post**](docs/TwoFactorApi.md#two_factor_send_email_login_post)                                                                                                                                | **POST** /two-factor/send-email-login                                                    |
| _TwoFactorApi_                          | [**two_factor_send_email_post**](docs/TwoFactorApi.md#two_factor_send_email_post)                                                                                                                                            | **POST** /two-factor/send-email                                                          |
| _TwoFactorApi_                          | [**two_factor_webauthn_delete**](docs/TwoFactorApi.md#two_factor_webauthn_delete)                                                                                                                                            | **DELETE** /two-factor/webauthn                                                          |
| _TwoFactorApi_                          | [**two_factor_webauthn_post**](docs/TwoFactorApi.md#two_factor_webauthn_post)                                                                                                                                                | **POST** /two-factor/webauthn                                                            |
| _TwoFactorApi_                          | [**two_factor_webauthn_put**](docs/TwoFactorApi.md#two_factor_webauthn_put)                                                                                                                                                  | **PUT** /two-factor/webauthn                                                             |
| _TwoFactorApi_                          | [**two_factor_yubikey_post**](docs/TwoFactorApi.md#two_factor_yubikey_post)                                                                                                                                                  | **POST** /two-factor/yubikey                                                             |
| _TwoFactorApi_                          | [**two_factor_yubikey_put**](docs/TwoFactorApi.md#two_factor_yubikey_put)                                                                                                                                                    | **PUT** /two-factor/yubikey                                                              |
| _UsersApi_                              | [**users_id_public_key_get**](docs/UsersApi.md#users_id_public_key_get)                                                                                                                                                      | **GET** /users/{id}/public-key                                                           |
| _WebAuthnApi_                           | [**webauthn_assertion_options_post**](docs/WebAuthnApi.md#webauthn_assertion_options_post)                                                                                                                                   | **POST** /webauthn/assertion-options                                                     |
| _WebAuthnApi_                           | [**webauthn_attestation_options_post**](docs/WebAuthnApi.md#webauthn_attestation_options_post)                                                                                                                               | **POST** /webauthn/attestation-options                                                   |
| _WebAuthnApi_                           | [**webauthn_get**](docs/WebAuthnApi.md#webauthn_get)                                                                                                                                                                         | **GET** /webauthn                                                                        |
| _WebAuthnApi_                           | [**webauthn_id_delete_post**](docs/WebAuthnApi.md#webauthn_id_delete_post)                                                                                                                                                   | **POST** /webauthn/{id}/delete                                                           |
| _WebAuthnApi_                           | [**webauthn_post**](docs/WebAuthnApi.md#webauthn_post)                                                                                                                                                                       | **POST** /webauthn                                                                       |
| _WebAuthnApi_                           | [**webauthn_put**](docs/WebAuthnApi.md#webauthn_put)                                                                                                                                                                         | **PUT** /webauthn                                                                        |

## Documentation For Models

- [AccessPolicyRequest](docs/AccessPolicyRequest.md)
- [AccessTokenCreateRequestModel](docs/AccessTokenCreateRequestModel.md)
- [AccessTokenCreationResponseModel](docs/AccessTokenCreationResponseModel.md)
- [AccessTokenResponseModel](docs/AccessTokenResponseModel.md)
- [AccessTokenResponseModelListResponseModel](docs/AccessTokenResponseModelListResponseModel.md)
- [AdminAuthRequestUpdateRequestModel](docs/AdminAuthRequestUpdateRequestModel.md)
- [Algorithm](docs/Algorithm.md)
- [ApiKeyResponseModel](docs/ApiKeyResponseModel.md)
- [AssertionOptions](docs/AssertionOptions.md)
- [AssertionResponse](docs/AssertionResponse.md)
- [AttachmentRequestModel](docs/AttachmentRequestModel.md)
- [AttachmentResponseModel](docs/AttachmentResponseModel.md)
- [AttachmentUploadDataResponseModel](docs/AttachmentUploadDataResponseModel.md)
- [AttestationConveyancePreference](docs/AttestationConveyancePreference.md)
- [AuthRequestCreateRequestModel](docs/AuthRequestCreateRequestModel.md)
- [AuthRequestResponseModel](docs/AuthRequestResponseModel.md)
- [AuthRequestResponseModelListResponseModel](docs/AuthRequestResponseModelListResponseModel.md)
- [AuthRequestType](docs/AuthRequestType.md)
- [AuthRequestUpdateRequestModel](docs/AuthRequestUpdateRequestModel.md)
- [AuthenticationExtensionsClientInputs](docs/AuthenticationExtensionsClientInputs.md)
- [AuthenticationExtensionsClientOutputs](docs/AuthenticationExtensionsClientOutputs.md)
- [AuthenticatorAssertionRawResponse](docs/AuthenticatorAssertionRawResponse.md)
- [AuthenticatorAttachment](docs/AuthenticatorAttachment.md)
- [AuthenticatorAttestationRawResponse](docs/AuthenticatorAttestationRawResponse.md)
- [AuthenticatorSelection](docs/AuthenticatorSelection.md)
- [AuthenticatorTransport](docs/AuthenticatorTransport.md)
- [BaseSecretResponseModel](docs/BaseSecretResponseModel.md)
- [BaseSecretResponseModelListResponseModel](docs/BaseSecretResponseModelListResponseModel.md)
- [BillingCustomerDiscount](docs/BillingCustomerDiscount.md)
- [BillingHistoryResponseModel](docs/BillingHistoryResponseModel.md)
- [BillingInvoice](docs/BillingInvoice.md)
- [BillingPaymentResponseModel](docs/BillingPaymentResponseModel.md)
- [BillingSource](docs/BillingSource.md)
- [BillingSubscription](docs/BillingSubscription.md)
- [BillingSubscriptionItem](docs/BillingSubscriptionItem.md)
- [BillingSubscriptionUpcomingInvoice](docs/BillingSubscriptionUpcomingInvoice.md)
- [BillingTransaction](docs/BillingTransaction.md)
- [BitPayInvoiceRequestModel](docs/BitPayInvoiceRequestModel.md)
- [BulkCollectionAccessRequestModel](docs/BulkCollectionAccessRequestModel.md)
- [BulkDeleteResponseModel](docs/BulkDeleteResponseModel.md)
- [BulkDeleteResponseModelListResponseModel](docs/BulkDeleteResponseModelListResponseModel.md)
- [BulkDenyAdminAuthRequestRequestModel](docs/BulkDenyAdminAuthRequestRequestModel.md)
- [CipherAttachmentModel](docs/CipherAttachmentModel.md)
- [CipherBulkDeleteRequestModel](docs/CipherBulkDeleteRequestModel.md)
- [CipherBulkMoveRequestModel](docs/CipherBulkMoveRequestModel.md)
- [CipherBulkRestoreRequestModel](docs/CipherBulkRestoreRequestModel.md)
- [CipherBulkShareRequestModel](docs/CipherBulkShareRequestModel.md)
- [CipherBulkUpdateCollectionsRequestModel](docs/CipherBulkUpdateCollectionsRequestModel.md)
- [CipherCardModel](docs/CipherCardModel.md)
- [CipherCollectionsRequestModel](docs/CipherCollectionsRequestModel.md)
- [CipherCreateRequestModel](docs/CipherCreateRequestModel.md)
- [CipherDetailsResponseModel](docs/CipherDetailsResponseModel.md)
- [CipherDetailsResponseModelListResponseModel](docs/CipherDetailsResponseModelListResponseModel.md)
- [CipherFido2CredentialModel](docs/CipherFido2CredentialModel.md)
- [CipherFieldModel](docs/CipherFieldModel.md)
- [CipherIdentityModel](docs/CipherIdentityModel.md)
- [CipherLoginModel](docs/CipherLoginModel.md)
- [CipherLoginUriModel](docs/CipherLoginUriModel.md)
- [CipherMiniDetailsResponseModel](docs/CipherMiniDetailsResponseModel.md)
- [CipherMiniDetailsResponseModelListResponseModel](docs/CipherMiniDetailsResponseModelListResponseModel.md)
- [CipherMiniResponseModel](docs/CipherMiniResponseModel.md)
- [CipherMiniResponseModelListResponseModel](docs/CipherMiniResponseModelListResponseModel.md)
- [CipherPartialRequestModel](docs/CipherPartialRequestModel.md)
- [CipherPasswordHistoryModel](docs/CipherPasswordHistoryModel.md)
- [CipherRepromptType](docs/CipherRepromptType.md)
- [CipherRequestModel](docs/CipherRequestModel.md)
- [CipherResponseModel](docs/CipherResponseModel.md)
- [CipherSecureNoteModel](docs/CipherSecureNoteModel.md)
- [CipherShareRequestModel](docs/CipherShareRequestModel.md)
- [CipherType](docs/CipherType.md)
- [CipherWithIdRequestModel](docs/CipherWithIdRequestModel.md)
- [CollectionAccessDetailsResponseModel](docs/CollectionAccessDetailsResponseModel.md)
- [CollectionAccessDetailsResponseModelListResponseModel](docs/CollectionAccessDetailsResponseModelListResponseModel.md)
- [CollectionBulkDeleteRequestModel](docs/CollectionBulkDeleteRequestModel.md)
- [CollectionDetailsResponseModel](docs/CollectionDetailsResponseModel.md)
- [CollectionDetailsResponseModelListResponseModel](docs/CollectionDetailsResponseModelListResponseModel.md)
- [CollectionRequestModel](docs/CollectionRequestModel.md)
- [CollectionResponseModel](docs/CollectionResponseModel.md)
- [CollectionResponseModelListResponseModel](docs/CollectionResponseModelListResponseModel.md)
- [CollectionWithIdRequestModel](docs/CollectionWithIdRequestModel.md)
- [ConfigResponseModel](docs/ConfigResponseModel.md)
- [CreateClientOrganizationRequestBody](docs/CreateClientOrganizationRequestBody.md)
- [CredentialCreateOptions](docs/CredentialCreateOptions.md)
- [DeleteRecoverRequestModel](docs/DeleteRecoverRequestModel.md)
- [DeviceKeysRequestModel](docs/DeviceKeysRequestModel.md)
- [DeviceKeysUpdateRequestModel](docs/DeviceKeysUpdateRequestModel.md)
- [DeviceRequestModel](docs/DeviceRequestModel.md)
- [DeviceResponseModel](docs/DeviceResponseModel.md)
- [DeviceResponseModelListResponseModel](docs/DeviceResponseModelListResponseModel.md)
- [DeviceTokenRequestModel](docs/DeviceTokenRequestModel.md)
- [DeviceType](docs/DeviceType.md)
- [DeviceVerificationRequestModel](docs/DeviceVerificationRequestModel.md)
- [DeviceVerificationResponseModel](docs/DeviceVerificationResponseModel.md)
- [DomainsResponseModel](docs/DomainsResponseModel.md)
- [EmailRequestModel](docs/EmailRequestModel.md)
- [EmailTokenRequestModel](docs/EmailTokenRequestModel.md)
- [EmergencyAccessGranteeDetailsResponseModel](docs/EmergencyAccessGranteeDetailsResponseModel.md)
- [EmergencyAccessGranteeDetailsResponseModelListResponseModel](docs/EmergencyAccessGranteeDetailsResponseModelListResponseModel.md)
- [EmergencyAccessGrantorDetailsResponseModel](docs/EmergencyAccessGrantorDetailsResponseModel.md)
- [EmergencyAccessGrantorDetailsResponseModelListResponseModel](docs/EmergencyAccessGrantorDetailsResponseModelListResponseModel.md)
- [EmergencyAccessInviteRequestModel](docs/EmergencyAccessInviteRequestModel.md)
- [EmergencyAccessPasswordRequestModel](docs/EmergencyAccessPasswordRequestModel.md)
- [EmergencyAccessStatusType](docs/EmergencyAccessStatusType.md)
- [EmergencyAccessTakeoverResponseModel](docs/EmergencyAccessTakeoverResponseModel.md)
- [EmergencyAccessType](docs/EmergencyAccessType.md)
- [EmergencyAccessUpdateRequestModel](docs/EmergencyAccessUpdateRequestModel.md)
- [EmergencyAccessViewResponseModel](docs/EmergencyAccessViewResponseModel.md)
- [EmergencyAccessWithIdRequestModel](docs/EmergencyAccessWithIdRequestModel.md)
- [EnvironmentConfigResponseModel](docs/EnvironmentConfigResponseModel.md)
- [EventResponseModel](docs/EventResponseModel.md)
- [EventResponseModelListResponseModel](docs/EventResponseModelListResponseModel.md)
- [EventSystemUser](docs/EventSystemUser.md)
- [EventType](docs/EventType.md)
- [ExpandedTaxInfoUpdateRequestModel](docs/ExpandedTaxInfoUpdateRequestModel.md)
- [Fido2User](docs/Fido2User.md)
- [FieldType](docs/FieldType.md)
- [FileUploadType](docs/FileUploadType.md)
- [FolderRequestModel](docs/FolderRequestModel.md)
- [FolderResponseModel](docs/FolderResponseModel.md)
- [FolderResponseModelListResponseModel](docs/FolderResponseModelListResponseModel.md)
- [FolderWithIdRequestModel](docs/FolderWithIdRequestModel.md)
- [GetSecretsRequestModel](docs/GetSecretsRequestModel.md)
- [GlobalDomains](docs/GlobalDomains.md)
- [GlobalEquivalentDomainsType](docs/GlobalEquivalentDomainsType.md)
- [GrantedAccessPolicyRequest](docs/GrantedAccessPolicyRequest.md)
- [GrantedProjectAccessPolicyPermissionDetailsResponseModel](docs/GrantedProjectAccessPolicyPermissionDetailsResponseModel.md)
- [GrantedProjectAccessPolicyResponseModel](docs/GrantedProjectAccessPolicyResponseModel.md)
- [Group](docs/Group.md)
- [GroupAccessPolicyResponseModel](docs/GroupAccessPolicyResponseModel.md)
- [GroupBulkRequestModel](docs/GroupBulkRequestModel.md)
- [GroupDetailsResponseModel](docs/GroupDetailsResponseModel.md)
- [GroupDetailsResponseModelListResponseModel](docs/GroupDetailsResponseModelListResponseModel.md)
- [GroupRequestModel](docs/GroupRequestModel.md)
- [GroupResponseModel](docs/GroupResponseModel.md)
- [ImportCiphersRequestModel](docs/ImportCiphersRequestModel.md)
- [ImportOrganizationCiphersRequestModel](docs/ImportOrganizationCiphersRequestModel.md)
- [ImportOrganizationUsersRequestModel](docs/ImportOrganizationUsersRequestModel.md)
- [InnerProjectExportResponseModel](docs/InnerProjectExportResponseModel.md)
- [InnerProjectImportRequestModel](docs/InnerProjectImportRequestModel.md)
- [InnerSecretExportResponseModel](docs/InnerSecretExportResponseModel.md)
- [InnerSecretImportRequestModel](docs/InnerSecretImportRequestModel.md)
- [InstallationRequestModel](docs/InstallationRequestModel.md)
- [InstallationResponseModel](docs/InstallationResponseModel.md)
- [Int32Int32KeyValuePair](docs/Int32Int32KeyValuePair.md)
- [KdfRequestModel](docs/KdfRequestModel.md)
- [KdfType](docs/KdfType.md)
- [KeyModel](docs/KeyModel.md)
- [KeyPairRequestBody](docs/KeyPairRequestBody.md)
- [KeysRequestModel](docs/KeysRequestModel.md)
- [KeysResponseModel](docs/KeysResponseModel.md)
- [LicenseType](docs/LicenseType.md)
- [MasterPasswordPolicyResponseModel](docs/MasterPasswordPolicyResponseModel.md)
- [MemberDecryptionType](docs/MemberDecryptionType.md)
- [OpenIdConnectRedirectBehavior](docs/OpenIdConnectRedirectBehavior.md)
- [OptionalCipherDetailsResponseModel](docs/OptionalCipherDetailsResponseModel.md)
- [OrganizationApiKeyInformation](docs/OrganizationApiKeyInformation.md)
- [OrganizationApiKeyInformationListResponseModel](docs/OrganizationApiKeyInformationListResponseModel.md)
- [OrganizationApiKeyRequestModel](docs/OrganizationApiKeyRequestModel.md)
- [OrganizationApiKeyType](docs/OrganizationApiKeyType.md)
- [OrganizationAuthRequestUpdateManyRequestModel](docs/OrganizationAuthRequestUpdateManyRequestModel.md)
- [OrganizationAutoEnrollStatusResponseModel](docs/OrganizationAutoEnrollStatusResponseModel.md)
- [OrganizationBillingStatusResponseModel](docs/OrganizationBillingStatusResponseModel.md)
- [OrganizationCollectionManagementUpdateRequestModel](docs/OrganizationCollectionManagementUpdateRequestModel.md)
- [OrganizationConnectionRequestModel](docs/OrganizationConnectionRequestModel.md)
- [OrganizationConnectionResponseModel](docs/OrganizationConnectionResponseModel.md)
- [OrganizationConnectionType](docs/OrganizationConnectionType.md)
- [OrganizationCountsResponseModel](docs/OrganizationCountsResponseModel.md)
- [OrganizationCreateRequestModel](docs/OrganizationCreateRequestModel.md)
- [OrganizationDomainRequestModel](docs/OrganizationDomainRequestModel.md)
- [OrganizationDomainResponseModel](docs/OrganizationDomainResponseModel.md)
- [OrganizationDomainResponseModelListResponseModel](docs/OrganizationDomainResponseModelListResponseModel.md)
- [OrganizationDomainSsoDetailsRequestModel](docs/OrganizationDomainSsoDetailsRequestModel.md)
- [OrganizationDomainSsoDetailsResponseModel](docs/OrganizationDomainSsoDetailsResponseModel.md)
- [OrganizationKeysRequestModel](docs/OrganizationKeysRequestModel.md)
- [OrganizationKeysResponseModel](docs/OrganizationKeysResponseModel.md)
- [OrganizationLicense](docs/OrganizationLicense.md)
- [OrganizationPublicKeyResponseModel](docs/OrganizationPublicKeyResponseModel.md)
- [OrganizationResponseModel](docs/OrganizationResponseModel.md)
- [OrganizationSeatRequestModel](docs/OrganizationSeatRequestModel.md)
- [OrganizationSponsorshipCreateRequestModel](docs/OrganizationSponsorshipCreateRequestModel.md)
- [OrganizationSponsorshipRedeemRequestModel](docs/OrganizationSponsorshipRedeemRequestModel.md)
- [OrganizationSponsorshipRequestModel](docs/OrganizationSponsorshipRequestModel.md)
- [OrganizationSponsorshipResponseModel](docs/OrganizationSponsorshipResponseModel.md)
- [OrganizationSponsorshipSyncRequestModel](docs/OrganizationSponsorshipSyncRequestModel.md)
- [OrganizationSponsorshipSyncResponseModel](docs/OrganizationSponsorshipSyncResponseModel.md)
- [OrganizationSsoRequestModel](docs/OrganizationSsoRequestModel.md)
- [OrganizationSsoResponseModel](docs/OrganizationSsoResponseModel.md)
- [OrganizationSubscriptionResponseModel](docs/OrganizationSubscriptionResponseModel.md)
- [OrganizationSubscriptionUpdateRequestModel](docs/OrganizationSubscriptionUpdateRequestModel.md)
- [OrganizationUpdateRequestModel](docs/OrganizationUpdateRequestModel.md)
- [OrganizationUpgradeRequestModel](docs/OrganizationUpgradeRequestModel.md)
- [OrganizationUserAcceptInitRequestModel](docs/OrganizationUserAcceptInitRequestModel.md)
- [OrganizationUserAcceptRequestModel](docs/OrganizationUserAcceptRequestModel.md)
- [OrganizationUserBulkConfirmRequestModel](docs/OrganizationUserBulkConfirmRequestModel.md)
- [OrganizationUserBulkConfirmRequestModelEntry](docs/OrganizationUserBulkConfirmRequestModelEntry.md)
- [OrganizationUserBulkRequestModel](docs/OrganizationUserBulkRequestModel.md)
- [OrganizationUserBulkResponseModel](docs/OrganizationUserBulkResponseModel.md)
- [OrganizationUserBulkResponseModelListResponseModel](docs/OrganizationUserBulkResponseModelListResponseModel.md)
- [OrganizationUserConfirmRequestModel](docs/OrganizationUserConfirmRequestModel.md)
- [OrganizationUserDetailsResponseModel](docs/OrganizationUserDetailsResponseModel.md)
- [OrganizationUserInviteRequestModel](docs/OrganizationUserInviteRequestModel.md)
- [OrganizationUserPublicKeyResponseModel](docs/OrganizationUserPublicKeyResponseModel.md)
- [OrganizationUserPublicKeyResponseModelListResponseModel](docs/OrganizationUserPublicKeyResponseModelListResponseModel.md)
- [OrganizationUserResetPasswordDetailsResponseModel](docs/OrganizationUserResetPasswordDetailsResponseModel.md)
- [OrganizationUserResetPasswordDetailsResponseModelListResponseModel](docs/OrganizationUserResetPasswordDetailsResponseModelListResponseModel.md)
- [OrganizationUserResetPasswordEnrollmentRequestModel](docs/OrganizationUserResetPasswordEnrollmentRequestModel.md)
- [OrganizationUserResetPasswordRequestModel](docs/OrganizationUserResetPasswordRequestModel.md)
- [OrganizationUserStatusType](docs/OrganizationUserStatusType.md)
- [OrganizationUserType](docs/OrganizationUserType.md)
- [OrganizationUserUpdateRequestModel](docs/OrganizationUserUpdateRequestModel.md)
- [OrganizationUserUserDetailsResponseModel](docs/OrganizationUserUserDetailsResponseModel.md)
- [OrganizationUserUserDetailsResponseModelListResponseModel](docs/OrganizationUserUserDetailsResponseModelListResponseModel.md)
- [OrganizationVerifyBankRequestModel](docs/OrganizationVerifyBankRequestModel.md)
- [OrganizationVerifyDeleteRecoverRequestModel](docs/OrganizationVerifyDeleteRecoverRequestModel.md)
- [OtherDeviceKeysUpdateRequestModel](docs/OtherDeviceKeysUpdateRequestModel.md)
- [PasswordHintRequestModel](docs/PasswordHintRequestModel.md)
- [PasswordManagerPlanFeaturesResponseModel](docs/PasswordManagerPlanFeaturesResponseModel.md)
- [PasswordRequestModel](docs/PasswordRequestModel.md)
- [PaymentMethodType](docs/PaymentMethodType.md)
- [PaymentRequestModel](docs/PaymentRequestModel.md)
- [PaymentResponseModel](docs/PaymentResponseModel.md)
- [PendingOrganizationAuthRequestResponseModel](docs/PendingOrganizationAuthRequestResponseModel.md)
- [PendingOrganizationAuthRequestResponseModelListResponseModel](docs/PendingOrganizationAuthRequestResponseModelListResponseModel.md)
- [PeopleAccessPoliciesRequestModel](docs/PeopleAccessPoliciesRequestModel.md)
- [Permissions](docs/Permissions.md)
- [PlanResponseModel](docs/PlanResponseModel.md)
- [PlanResponseModelListResponseModel](docs/PlanResponseModelListResponseModel.md)
- [PlanSponsorshipType](docs/PlanSponsorshipType.md)
- [PlanType](docs/PlanType.md)
- [PolicyRequestModel](docs/PolicyRequestModel.md)
- [PolicyResponseModel](docs/PolicyResponseModel.md)
- [PolicyResponseModelListResponseModel](docs/PolicyResponseModelListResponseModel.md)
- [PolicyType](docs/PolicyType.md)
- [PotentialGranteeResponseModel](docs/PotentialGranteeResponseModel.md)
- [PotentialGranteeResponseModelListResponseModel](docs/PotentialGranteeResponseModelListResponseModel.md)
- [ProductTierType](docs/ProductTierType.md)
- [ProfileOrganizationResponseModel](docs/ProfileOrganizationResponseModel.md)
- [ProfileOrganizationResponseModelListResponseModel](docs/ProfileOrganizationResponseModelListResponseModel.md)
- [ProfileProviderOrganizationResponseModel](docs/ProfileProviderOrganizationResponseModel.md)
- [ProfileProviderResponseModel](docs/ProfileProviderResponseModel.md)
- [ProfileResponseModel](docs/ProfileResponseModel.md)
- [ProjectCountsResponseModel](docs/ProjectCountsResponseModel.md)
- [ProjectCreateRequestModel](docs/ProjectCreateRequestModel.md)
- [ProjectPeopleAccessPoliciesResponseModel](docs/ProjectPeopleAccessPoliciesResponseModel.md)
- [ProjectResponseModel](docs/ProjectResponseModel.md)
- [ProjectResponseModelListResponseModel](docs/ProjectResponseModelListResponseModel.md)
- [ProjectServiceAccountsAccessPoliciesRequestModel](docs/ProjectServiceAccountsAccessPoliciesRequestModel.md)
- [ProjectServiceAccountsAccessPoliciesResponseModel](docs/ProjectServiceAccountsAccessPoliciesResponseModel.md)
- [ProjectUpdateRequestModel](docs/ProjectUpdateRequestModel.md)
- [ProtectedDeviceResponseModel](docs/ProtectedDeviceResponseModel.md)
- [ProviderOrganizationAddRequestModel](docs/ProviderOrganizationAddRequestModel.md)
- [ProviderOrganizationCreateRequestModel](docs/ProviderOrganizationCreateRequestModel.md)
- [ProviderOrganizationOrganizationDetailsResponseModel](docs/ProviderOrganizationOrganizationDetailsResponseModel.md)
- [ProviderOrganizationOrganizationDetailsResponseModelListResponseModel](docs/ProviderOrganizationOrganizationDetailsResponseModelListResponseModel.md)
- [ProviderOrganizationResponseModel](docs/ProviderOrganizationResponseModel.md)
- [ProviderResponseModel](docs/ProviderResponseModel.md)
- [ProviderSetupRequestModel](docs/ProviderSetupRequestModel.md)
- [ProviderStatusType](docs/ProviderStatusType.md)
- [ProviderType](docs/ProviderType.md)
- [ProviderUpdateRequestModel](docs/ProviderUpdateRequestModel.md)
- [ProviderUserAcceptRequestModel](docs/ProviderUserAcceptRequestModel.md)
- [ProviderUserBulkConfirmRequestModel](docs/ProviderUserBulkConfirmRequestModel.md)
- [ProviderUserBulkConfirmRequestModelEntry](docs/ProviderUserBulkConfirmRequestModelEntry.md)
- [ProviderUserBulkRequestModel](docs/ProviderUserBulkRequestModel.md)
- [ProviderUserBulkResponseModel](docs/ProviderUserBulkResponseModel.md)
- [ProviderUserBulkResponseModelListResponseModel](docs/ProviderUserBulkResponseModelListResponseModel.md)
- [ProviderUserConfirmRequestModel](docs/ProviderUserConfirmRequestModel.md)
- [ProviderUserInviteRequestModel](docs/ProviderUserInviteRequestModel.md)
- [ProviderUserPublicKeyResponseModel](docs/ProviderUserPublicKeyResponseModel.md)
- [ProviderUserPublicKeyResponseModelListResponseModel](docs/ProviderUserPublicKeyResponseModelListResponseModel.md)
- [ProviderUserResponseModel](docs/ProviderUserResponseModel.md)
- [ProviderUserStatusType](docs/ProviderUserStatusType.md)
- [ProviderUserType](docs/ProviderUserType.md)
- [ProviderUserUpdateRequestModel](docs/ProviderUserUpdateRequestModel.md)
- [ProviderUserUserDetailsResponseModel](docs/ProviderUserUserDetailsResponseModel.md)
- [ProviderUserUserDetailsResponseModelListResponseModel](docs/ProviderUserUserDetailsResponseModelListResponseModel.md)
- [ProviderVerifyDeleteRecoverRequestModel](docs/ProviderVerifyDeleteRecoverRequestModel.md)
- [PubKeyCredParam](docs/PubKeyCredParam.md)
- [PublicKeyCredentialDescriptor](docs/PublicKeyCredentialDescriptor.md)
- [PublicKeyCredentialRpEntity](docs/PublicKeyCredentialRpEntity.md)
- [PublicKeyCredentialType](docs/PublicKeyCredentialType.md)
- [PushDeviceRequestModel](docs/PushDeviceRequestModel.md)
- [PushRegistrationRequestModel](docs/PushRegistrationRequestModel.md)
- [PushSendRequestModel](docs/PushSendRequestModel.md)
- [PushType](docs/PushType.md)
- [PushUpdateRequestModel](docs/PushUpdateRequestModel.md)
- [RequestSmAccessRequestModel](docs/RequestSmAccessRequestModel.md)
- [ResetPasswordWithOrgIdRequestModel](docs/ResetPasswordWithOrgIdRequestModel.md)
- [ResponseData](docs/ResponseData.md)
- [RevokeAccessTokensRequest](docs/RevokeAccessTokensRequest.md)
- [Saml2BindingType](docs/Saml2BindingType.md)
- [Saml2NameIdFormat](docs/Saml2NameIdFormat.md)
- [Saml2SigningBehavior](docs/Saml2SigningBehavior.md)
- [SecretAccessPoliciesRequestsModel](docs/SecretAccessPoliciesRequestsModel.md)
- [SecretAccessPoliciesResponseModel](docs/SecretAccessPoliciesResponseModel.md)
- [SecretCreateRequestModel](docs/SecretCreateRequestModel.md)
- [SecretResponseInnerProject](docs/SecretResponseInnerProject.md)
- [SecretResponseModel](docs/SecretResponseModel.md)
- [SecretUpdateRequestModel](docs/SecretUpdateRequestModel.md)
- [SecretVerificationRequestModel](docs/SecretVerificationRequestModel.md)
- [SecretWithProjectsInnerProject](docs/SecretWithProjectsInnerProject.md)
- [SecretWithProjectsListResponseModel](docs/SecretWithProjectsListResponseModel.md)
- [SecretsManagerPlanFeaturesResponseModel](docs/SecretsManagerPlanFeaturesResponseModel.md)
- [SecretsManagerSubscribeRequestModel](docs/SecretsManagerSubscribeRequestModel.md)
- [SecretsManagerSubscriptionUpdateRequestModel](docs/SecretsManagerSubscriptionUpdateRequestModel.md)
- [SecretsSyncResponseModel](docs/SecretsSyncResponseModel.md)
- [SecretsWithProjectsInnerSecret](docs/SecretsWithProjectsInnerSecret.md)
- [SecureNoteType](docs/SecureNoteType.md)
- [SelectionReadOnlyRequestModel](docs/SelectionReadOnlyRequestModel.md)
- [SelectionReadOnlyResponseModel](docs/SelectionReadOnlyResponseModel.md)
- [SelfHostedOrganizationLicenseRequestModel](docs/SelfHostedOrganizationLicenseRequestModel.md)
- [SendAccessRequestModel](docs/SendAccessRequestModel.md)
- [SendFileModel](docs/SendFileModel.md)
- [SendFileUploadDataResponseModel](docs/SendFileUploadDataResponseModel.md)
- [SendRequestModel](docs/SendRequestModel.md)
- [SendResponseModel](docs/SendResponseModel.md)
- [SendResponseModelListResponseModel](docs/SendResponseModelListResponseModel.md)
- [SendTextModel](docs/SendTextModel.md)
- [SendType](docs/SendType.md)
- [SendWithIdRequestModel](docs/SendWithIdRequestModel.md)
- [ServerConfigResponseModel](docs/ServerConfigResponseModel.md)
- [ServiceAccountAccessPolicyResponseModel](docs/ServiceAccountAccessPolicyResponseModel.md)
- [ServiceAccountCountsResponseModel](docs/ServiceAccountCountsResponseModel.md)
- [ServiceAccountCreateRequestModel](docs/ServiceAccountCreateRequestModel.md)
- [ServiceAccountGrantedPoliciesPermissionDetailsResponseModel](docs/ServiceAccountGrantedPoliciesPermissionDetailsResponseModel.md)
- [ServiceAccountGrantedPoliciesRequestModel](docs/ServiceAccountGrantedPoliciesRequestModel.md)
- [ServiceAccountPeopleAccessPoliciesResponseModel](docs/ServiceAccountPeopleAccessPoliciesResponseModel.md)
- [ServiceAccountResponseModel](docs/ServiceAccountResponseModel.md)
- [ServiceAccountSecretsDetailsResponseModel](docs/ServiceAccountSecretsDetailsResponseModel.md)
- [ServiceAccountSecretsDetailsResponseModelListResponseModel](docs/ServiceAccountSecretsDetailsResponseModelListResponseModel.md)
- [ServiceAccountUpdateRequestModel](docs/ServiceAccountUpdateRequestModel.md)
- [SetKeyConnectorKeyRequestModel](docs/SetKeyConnectorKeyRequestModel.md)
- [SetPasswordRequestModel](docs/SetPasswordRequestModel.md)
- [SmExportResponseModel](docs/SmExportResponseModel.md)
- [SmImportRequestModel](docs/SmImportRequestModel.md)
- [SsoConfigurationData](docs/SsoConfigurationData.md)
- [SsoConfigurationDataRequest](docs/SsoConfigurationDataRequest.md)
- [SsoType](docs/SsoType.md)
- [SsoUrls](docs/SsoUrls.md)
- [StorageRequestModel](docs/StorageRequestModel.md)
- [SubscriptionCancellationRequestModel](docs/SubscriptionCancellationRequestModel.md)
- [SubscriptionResponseModel](docs/SubscriptionResponseModel.md)
- [SyncResponseModel](docs/SyncResponseModel.md)
- [TaxInfoResponseModel](docs/TaxInfoResponseModel.md)
- [TaxInfoUpdateRequestModel](docs/TaxInfoUpdateRequestModel.md)
- [TaxInformationRequestBody](docs/TaxInformationRequestBody.md)
- [TaxRateResponseModel](docs/TaxRateResponseModel.md)
- [TaxRateResponseModelListResponseModel](docs/TaxRateResponseModelListResponseModel.md)
- [TransactionType](docs/TransactionType.md)
- [TwoFactorAuthenticatorDisableRequestModel](docs/TwoFactorAuthenticatorDisableRequestModel.md)
- [TwoFactorAuthenticatorResponseModel](docs/TwoFactorAuthenticatorResponseModel.md)
- [TwoFactorDuoResponseModel](docs/TwoFactorDuoResponseModel.md)
- [TwoFactorEmailRequestModel](docs/TwoFactorEmailRequestModel.md)
- [TwoFactorEmailResponseModel](docs/TwoFactorEmailResponseModel.md)
- [TwoFactorProviderRequestModel](docs/TwoFactorProviderRequestModel.md)
- [TwoFactorProviderResponseModel](docs/TwoFactorProviderResponseModel.md)
- [TwoFactorProviderResponseModelListResponseModel](docs/TwoFactorProviderResponseModelListResponseModel.md)
- [TwoFactorProviderType](docs/TwoFactorProviderType.md)
- [TwoFactorRecoverResponseModel](docs/TwoFactorRecoverResponseModel.md)
- [TwoFactorRecoveryRequestModel](docs/TwoFactorRecoveryRequestModel.md)
- [TwoFactorWebAuthnDeleteRequestModel](docs/TwoFactorWebAuthnDeleteRequestModel.md)
- [TwoFactorWebAuthnRequestModel](docs/TwoFactorWebAuthnRequestModel.md)
- [TwoFactorWebAuthnResponseModel](docs/TwoFactorWebAuthnResponseModel.md)
- [TwoFactorYubiKeyResponseModel](docs/TwoFactorYubiKeyResponseModel.md)
- [UpdateAvatarRequestModel](docs/UpdateAvatarRequestModel.md)
- [UpdateClientOrganizationRequestBody](docs/UpdateClientOrganizationRequestBody.md)
- [UpdateDevicesTrustRequestModel](docs/UpdateDevicesTrustRequestModel.md)
- [UpdateDomainsRequestModel](docs/UpdateDomainsRequestModel.md)
- [UpdateKeyRequestModel](docs/UpdateKeyRequestModel.md)
- [UpdateProfileRequestModel](docs/UpdateProfileRequestModel.md)
- [UpdateTdeOffboardingPasswordRequestModel](docs/UpdateTdeOffboardingPasswordRequestModel.md)
- [UpdateTempPasswordRequestModel](docs/UpdateTempPasswordRequestModel.md)
- [UpdateTwoFactorAuthenticatorRequestModel](docs/UpdateTwoFactorAuthenticatorRequestModel.md)
- [UpdateTwoFactorDuoRequestModel](docs/UpdateTwoFactorDuoRequestModel.md)
- [UpdateTwoFactorEmailRequestModel](docs/UpdateTwoFactorEmailRequestModel.md)
- [UpdateTwoFactorYubicoOtpRequestModel](docs/UpdateTwoFactorYubicoOtpRequestModel.md)
- [UriMatchType](docs/UriMatchType.md)
- [User](docs/User.md)
- [UserAccessPolicyResponseModel](docs/UserAccessPolicyResponseModel.md)
- [UserKeyResponseModel](docs/UserKeyResponseModel.md)
- [UserLicense](docs/UserLicense.md)
- [UserVerificationRequirement](docs/UserVerificationRequirement.md)
- [VerifyDeleteRecoverRequestModel](docs/VerifyDeleteRecoverRequestModel.md)
- [VerifyEmailRequestModel](docs/VerifyEmailRequestModel.md)
- [VerifyOtpRequestModel](docs/VerifyOtpRequestModel.md)
- [WebAuthnCredentialCreateOptionsResponseModel](docs/WebAuthnCredentialCreateOptionsResponseModel.md)
- [WebAuthnCredentialResponseModel](docs/WebAuthnCredentialResponseModel.md)
- [WebAuthnCredentialResponseModelListResponseModel](docs/WebAuthnCredentialResponseModelListResponseModel.md)
- [WebAuthnLoginAssertionOptionsResponseModel](docs/WebAuthnLoginAssertionOptionsResponseModel.md)
- [WebAuthnLoginCredentialCreateRequestModel](docs/WebAuthnLoginCredentialCreateRequestModel.md)
- [WebAuthnLoginCredentialUpdateRequestModel](docs/WebAuthnLoginCredentialUpdateRequestModel.md)
- [WebAuthnLoginRotateKeyRequestModel](docs/WebAuthnLoginRotateKeyRequestModel.md)
- [WebAuthnPrfStatus](docs/WebAuthnPrfStatus.md)

To get access to the crate's generated documentation, use:

```
cargo doc --open
```

## Author
